#!/bin/sh

start()
{
	if mountpoint -q /var/upload
	then
		:
	else
		mount -o bind /recordings/upload /var/upload
	fi
	# we do it here, so we can ignore the error
	# this module we need for sensors
	# option -b to allow blacklisting
	modprobe -b coretemp
	modprobe -b w83627ehf
	service lm-sensors restart
	return 0
}


stop()
{
	umount /var/upload
	return 0
}

case $1 in
  start|stop) "$1" ;;
esac

