#!/bin/bash

service apresacrec stop

touch /var/apresa/conf/synvid-install

kernelversion=`uname -r`
case "$kernelversion" in
6.1.*)
	dpkg-reconfigure synvid-k61
	;;
5.10.*)
	dpkg-reconfigure synvid-k510
	;;
4.19.*)
	dpkg-reconfigure synvid-k419
	;;
4.9.*)
	dpkg-reconfigure synvid-k49
	;;
3.16.*)
	dpkg-reconfigure synvid-k316
  dpkg-reconfigure synvid-k316b
	;;
3.13.*)
	dpkg-reconfigure synvid-k313
	;;
3.2.*)
	dpkg-reconfigure synvid-k3
	;;
2.*)
	dpkg-reconfigure synvid
	;;
esac

# the driver should be loaded now

LSRES=`lsmod | grep shdpci`
if [ "$LSRES" != "" ] ; then
	echo "Synway driver is active"
	psql apresa -c "INSERT INTO Configs(param,value,part) VALUES('crec',1,'s')"
	# enable line number column
	psql apresa -c "DELETE FROM configs WHERE param='col_linenr'"
	psql apresa -c "INSERT INTO configs VALUES('col_linenr','1','web')"
fi

service apresacrec start
