
CREATE TABLE CEAnswerTypes (
id SERIAL PRIMARY KEY,
description TEXT  ,
type INTEGER  ,
minval INTEGER  ,
maxval INTEGER
);

CREATE TABLE CEAnswers (
id SERIAL PRIMARY KEY,
callid INTEGER   ,
qid INTEGER   ,
answer INTEGER
);

CREATE TABLE CECalls (
id SERIAL PRIMARY KEY,
recordingid INT,
projectid INT,
status INT,
answercnt INT,
useraccid INT,
score REAL
);

CREATE TABLE CEForms (
id SERIAL PRIMARY KEY,
name TEXT
);

CREATE TABLE CEProjects (
id SERIAL PRIMARY KEY,
formid INTEGER  ,
name TEXT
);

CREATE TABLE CEQuestions (
id SERIAL PRIMARY KEY ,
qtext TEXT  ,
atypeid INTEGER  ,
formid INTEGER  ,
ordering INTEGER
);


CREATE INDEX idx_cecalls_projectid ON CECalls(projectid ASC);
CREATE INDEX idx_cecalls_recordingid ON CECalls(recordingid ASC);

ALTER TABLE Users ADD COLUMN evaluated INT DEFAULT(0);

INSERT INTO CEAnswerTypes(description,type) 
	VALUES (E'Good=2\\Avg.=1\\Poor=0',1);
INSERT INTO CEAnswerTypes(description,type)
	VALUES (E'Yes=10\\No=0',1);
INSERT INTO CEAnswerTypes(description,type)
	VALUES (E'Yes=10\\Y/N=5\\No=0',1);
INSERT INTO CEAnswerTypes(description,type)
	VALUES (E'++=2\\+=1\\0=0\\-=-1\\--=-2',1);

