
// permission constants
var PM_CE_MANAGE     = (1<<8);
var PM_CE_EVALUATE   = (1<<9);
var PM_CE_VIEW       = (1<<10);
var PM_CE_SUPERVISOR = (1<<18);
var PM_CE_SCHEDULING = (1<<19);
var PM_CE_VIEWOWNREPORTS = (1<<25);
var PM_CE_SELFEVALUATE = (1<<26);
var PM_CE_VIEW_LIVEDASH = (1<<27);
var PM_CE_EDIT_LIVEDASH = (1<<28);

function implode(glue, arr)
{
	var first = true;
	var t = '';
	for (ix in arr)
	{
		if (!first) t += ',';
		first = false;
		t += arr[ix];
	}
	return t;
}

function LastPos(strText,chToFind)
{
	for (var i=strText.length;i>=0;i--)
	{
		if (strText.charAt(i)==chToFind)
		{
			return i;
		}
	}
	return -1;
}
function getRootUrl()
{
	var rooturl = window.location.href;
	return rooturl.substring(0,LastPos(rooturl,'/')+1);
}
function getFileUrl()
{
	var rooturl = window.location.href;
	if (LastPos(rooturl,'?')==-1)
	{
		//return rooturl.substring(0,LastPos(rooturl,'/')+1);
		return rooturl;
	} else {
		return rooturl.substring(0,LastPos(rooturl,'?'));
	}
}

function doSearch()
{
	el = document.getElementById("search");
	if (el.style.display=="block")
	{
		el.style.display = "none";
	} else {
		el.style.display = "block";
	}
}

function doLogout()
{
	if (typeof(OnMoveToOtherPage)!="undefined")
	{
		if (OnMoveToOtherPage()==false)
		{
			return;
		}
	}

	var mainform = document.getElementById("mainform");
	mainform.action = getRootUrl();
	addData('act','logout');
	ActionSubmit();
}


function toHome()
{
	location.href = getRootUrl();
}


function toStat()
{
	window.location = "stat_index.htm"
}

function StringToArray(string){
	var result=[];
	var res = string.split("\r\n");
	
	for (i = 0; i < res.length-1; i++) { 
		var sub = res[i].split(": ");
		result[sub[0]]=sub[1];
		
	}
	return result;
}

function NoActionSubmit(script)
{
	location.href = GetSubmitUrl(script);
}

function GetSubmitUrl(script)
{
	var theform = document.getElementById("mainform");
	var url = getFileUrl();
	if (typeof(script)!='undefined')
	{
		url = script;
	}
	var first = true;
	if (theform)
	{
		for (var elem = theform.firstChild; elem; elem = elem.nextSibling)
		{
			if(elem.getAttribute){
				var value = elem.getAttribute("value");
				if (value)
				{
					if (first) url += "?";
					else {
						if (YAHOO.env.ua.ie) url += "&amp;";
						else url += "&";
					}
					first = false;
					url += elem.getAttribute("name")+"="+encodeURIComponent(value);
				}
			}
		}
	}
	return url;
}
function ActionSubmit()
{
  if (typeof(SessionToken)!='undefined')
  {
    addData('SessionToken',SessionToken);
  }
	var mainform = document.getElementById("mainform");
	//alert(mainform.action);
	//mainform.action = getFileUrl();
	//alert(mainform.action);
	mainform.submit();
}

function clearData()
{
	var theform = document.getElementById("mainform");
	var toclear = [];
	for (var elem = theform.firstChild; elem; elem = elem.nextSibling)
	{
		toclear.push( elem );
	}
	for (ix in toclear)
	{
		theform.removeChild( toclear[ix] );
	}
}

function isDataDefined(name)
{
	var theform = document.getElementById("mainform");
	if (typeof(theform.elements[name])!="undefined") return true;
	return false;
}

function addTokenToFormId(formid)
{
  var theform = document.getElementById(formid);
	newinput = document.createElement("input");
	newinput.setAttribute("type","hidden");
	newinput.setAttribute("name","SessionToken");
	newinput.setAttribute("value",SessionToken);
	theform.appendChild(newinput);
}

function addData(name,value)
{
	var theform = document.getElementById("mainform");
	// is it already there?
	for (var elem = theform.firstChild; elem; elem = elem.nextSibling)
	{
		if(elem.getAttribute){
			if (elem.getAttribute("name")==name)
			{
				elem.setAttribute("value",value);
				return;
			}
		}
	}
	// add it
	newinput = document.createElement("input");
	newinput.setAttribute("type","hidden");
	newinput.setAttribute("name",name);
	newinput.setAttribute("value",value);
	theform.appendChild(newinput);
}

function SortDirStr(oSortDir)
{
	if (oSortDir==YAHOO.widget.DataTable.CLASS_DESC)
	{
		return "desc";
	} else {
		return "asc";
	}
}

function HtmlQuote(text)
{
  if (text==null) return '';
  text = "" + text; // to ensure it is a string
	text = text.replace(/&/g,"&amp;");
	text = text.replace(/</g,"&lt;");
	text = text.replace(/>/g,"&gt;");
	text = text.replace(/"/g,"&quot;");
	return text;
}

function MoveTo(url)
{
	if (typeof(OnMoveToOtherPage)!="undefined")
	{
		if (OnMoveToOtherPage()==false)
		{
			return;
		}
	}
	window.location = url;
}

var MajorButtons_done = false;
function MajorButtons()
{
  if (MajorButtons_done) return;
  MajorButtons_done = true;
	if(!only_webclient)
	{
	
		var HomeBtn   = new YAHOO.widget.Button("HomeBtn");
		HomeBtn.on("click",function(){MoveTo(getRootUrl());});

		if (showtoolsmenu)
		{
			var aToolsMenu = [];
			if (to_phonebook)
			{
				aToolsMenu.push(
							{ text: "<%~Web.CTList%>" , onclick: {fn:function(){MoveTo(getRootUrl()+"contacts.php");}}, visible: to_phonebook }
				);
			}
			if(to_active){
				aToolsMenu.push(
						{ text: "<%~Web.ActiveCalls%>", onclick: {fn:function(){MoveTo(getRootUrl()+"active.php");}}}
				);
			}
			if(to_live){
				aToolsMenu.push(
						{ text: "<%~Web.ActiveCalls%> (<%~Main.All%>)", onclick: {fn:function(){MoveTo(getRootUrl()+"live.php");}}}
				);
			}
			if(pm_livedash)
			{
					aToolsMenu.push(
						{ text: "<%~Web.LiveDash%>", onclick: {fn:function(){MoveTo(getRootUrl()+"livedashboard.php");}}}
					);
			}
			if(pm_webclient)
			{
					aToolsMenu.push(
						{ text: "<%~Web.WebClient%>", onclick: {fn:function(){MoveTo(getRootUrl()+"webclient.php");}}}
					);
			}
			if (pm_stats)
			{
				aToolsMenu.push(
						{ text: "<%~Web.Statistics%>", onclick: {fn:function(){MoveTo(getRootUrl()+"stats.php");}}}
				);
			}
			if (pm_recyclebin)
			{
				aToolsMenu.push(
						{ text: "<%~Web.RecycleBin%>", onclick: {fn:function(){MoveTo(getRootUrl()+"recyclecalls.php");}}}
				);
			}
			if (calleval_on && (pms_extended&(PM_CE_SUPERVISOR|PM_CE_VIEW|PM_CE_VIEWOWNREPORTS|PM_CE_SELFEVALUATE))!=0)
			{
        // first page to show when choosing AgEv from menu
				var ce_first = '';
				if ((pms_extended&PM_CE_VIEWOWNREPORTS)>0) ce_first = 'cerepprojects.php';
				if ((pms_extended&PM_CE_SELFEVALUATE)>0) ce_first = 'ceevalsel.php';
				if ((pms_extended&PM_CE_VIEW      )>0) ce_first = 'cerepprojects.php';
				if ((pms_extended&PM_CE_EVALUATE  )>0) ce_first = 'ceevalsel.php';		
				if ((pms_extended&PM_CE_MANAGE    )>0) ce_first = 'ceprojects.php';
				if ((pms_extended&PM_CE_SUPERVISOR)>0) ce_first = 'dashboard.php';
				
				aToolsMenu.push(
						{ text: "<%~CE.AgentEv%>", onclick: {fn:function(){MoveTo(getRootUrl()+ce_first);}}}
				);
			}
			if (to_config)
			{
					aToolsMenu.push(
							{ text: "<%~PBX.VoipService%>" , onclick: {fn:function(){MoveTo(getRootUrl()+"voippbx.php");}} } );
							
					aToolsMenu.push(
            { text: "<%~Crypt.Certificates%>", onclick: {fn:function(){MoveTo(getRootUrl()+"certificates.php");}}});

          if(has_ED137)
          {
            aToolsMenu.push(
              { text: "ED137", onclick: {fn:function(){MoveTo(getRootUrl()+"ed137.php");}}}
            );
          }
			}
      if (exportimport)
      {
      aToolsMenu.push(
          { text: "<%~Web.Export%> &amp; <%~Web.Import%>" , onclick: {fn:function(){MoveTo(getRootUrl()+"exportimport.php");}} } );
      }
      if (to_config && clustering)
      {
        aToolsMenu.push(
            { text: "Cluster", onclick: {fn:function(){MoveTo(getRootUrl()+"cluster.php");}}}
        );
      }
      if (to_config||T2_Admin)
      {
        aToolsMenu.push(
            { text: "<%~System.System%>", onclick: {fn:function(){MoveTo(getRootUrl()+"systools.php");}}}
        );
      } else if (tenantadmin_audit)
      {
        aToolsMenu.push(
            { text: "<%~Web.AuditTrail%>", onclick: {fn:function(){MoveTo(getRootUrl()+"audit.php");}}}
        );
      } 
			if (pm_sysalarm)
			{
				aToolsMenu.push(
						{ text: "<%~System.SystemInfo%>", onclick: {fn:function(){MoveTo(getRootUrl()+"sysinfo.php");}}}
				);
      }
      if(MultiTenancy && tenantadmin_encrypt)
      {
        aToolsMenu.push(
          { text: "<%~Web.CallEncryption%>", onclick: {fn:function(){MoveTo(getRootUrl()+"tncallencryption.php");}}}
        );
      }

			var ToolsBtn = new YAHOO.widget.Button( "ToolsBtn",
				{type:'menu',menu:aToolsMenu}
			);
		} 
    
    if (!showtoolsmenu || aToolsMenu.length==0)
		{
			document.getElementById("ToolsBtn").style.display = "none";
		}

		if (Dom.get('HelpBtn'))
		{
			var HelpBtn = new YAHOO.widget.Button("HelpBtn");
			//HelpBtn
		}
		
		if (to_config || is_subadmin || pm_filter || pm_users || pm_anyusr || tenantadmin_exp)
		{
			var aConfigMenu = [];
			if (to_config || is_subadmin || pm_users || pm_anyusr)
			{
				aConfigMenu.push(
					{ text: "<%~PM.Users%>" , onclick: {fn:function(){MoveTo(getRootUrl()+"users.php");}} }
					);
					
			}
			if (to_config || pm_users)
			{
				aConfigMenu.push(
					{ text: "<%~PM.UserGroups%>" , onclick: {fn:function(){MoveTo(getRootUrl()+"groups.php");}} }
					);
			}
			if ( MultiTenancy && (to_config || T3_Admin || T2_Admin) )
			{
				aConfigMenu.push(
					{ text: "<%~Web.Tenants%>" , onclick: {fn:function(){MoveTo(getRootUrl()+"tenants.php");}} }
					);
			}
			if (to_config)
			{
				aConfigMenu.push(
					{ text: "<%~Options.Display%>" , onclick: {fn:function(){MoveTo(getRootUrl()+"displayconfig.php");}} }
					);
			}
			if (to_config || pm_filter)
			{
				aConfigMenu.push(
					{ text: "<%~Options.RecSettings%>" , onclick: {fn:function(){MoveTo(getRootUrl()+"recopt.php");}} }
					);
			}
			if (to_config)
			{
				//if (crec_on){}
				aConfigMenu.push(
					{ text: "<%~Options.CardSettings%>" 
					, onclick: {fn:function(){MoveTo(getRootUrl()+"crecopt.php");}}
					, disabled: (crec_on)?false:true
					} );
				if (mobiledevconf)
				{
					aConfigMenu.push(
						{ text: "<%~Web.ExternalPhones%>" , onclick: {fn:function(){MoveTo(getRootUrl()+"mobile_devices.php");}} } );
				}
				aConfigMenu.push(
					{ text: "<%~Options.SysSettings%>" , onclick: {fn:function(){MoveTo(getRootUrl()+"systemopt.php");}} } );
			}
      if (tenantadmin_exp)
      {
        aConfigMenu.push(
            { text: "<%~Options.ExportRecordings%>", onclick: {fn:function(){MoveTo(getRootUrl()+"tnexp.php");}}}
        );
      }
			var ConfigBtn = new YAHOO.widget.Button( "ConfigBtn",
				{type:'menu',menu:aConfigMenu}
			);
		} else {
			document.getElementById("ConfigBtn").style.display = "none";
		}
	}
	else
	{
		document.getElementById("HomeBtn").style.display = "none";
		document.getElementById("ToolsBtn").style.display = "none";
		document.getElementById("ConfigBtn").style.display = "none";
	}

  aUserMenu = [];
  if (personal_config)
  {
    aUserMenu.push(
      { text: "<%~Profile.PersonalSettings%>" , onclick: {fn:function(){MoveTo(getRootUrl()+"profile.php");}} } );
  }
  if (canlogoff)
	{
    aUserMenu.push(
      { text: "<%~Web.Logout%>" , onclick: {fn:doLogout} } );
  }
  if (aUserMenu.length==0)
  {
    var UserBtn = new YAHOO.widget.Button("UserBtn");
  } else
  {
    var UserBtn = new YAHOO.widget.Button("UserBtn",
          {type:'menu',menu:aUserMenu}
        );
  }
  
  if (SystemName!='' && to_config)
  {
    TrySetSystemName();
  }
}

function CreateSystemNameTextObj()
{
    var elem = document.createElement('span');
    elem.setAttribute('class',"sysname onlyWhenRoom");
    elem.appendChild( document.createTextNode(SystemName) );
    return elem;
}

function TrySetSystemName()
{
  // new layout
  var helplink = Dom.get('HelpLink');
  if (helplink==null) return;
  helplink.parentNode.insertBefore( CreateSystemNameTextObj() , helplink.nextSibling);
}


function SetHelpPage(page)
{
	Dom.get('HelpLink').href = 'manual/' + page + ".htm";
}
function strtrim(t)
{
	return t.replace(/^\s+|\s+$/g,'');
}

// e.g. format 3 as 03
function inZeros(value, length)
{
	var t = "" + value;
	var toadd = length - t.length;
	for (var i=0;i<toadd;i++)
	{
		t = "0" + t;
	}
	return t;
}

// format seconds as X:XX
function formatDuration(seconds)
{
	if (seconds<0) return '';
	var minutes = Math.floor( seconds / 60 );
	seconds -= minutes * 60;
	return minutes + ":" + inZeros(seconds,2);
}

// format seconds as X:XX:XX
function formatDurationLong(seconds)
{
	if (seconds<0) return '';
	var minutes = Math.floor( seconds / 60 );
	seconds -= minutes * 60;
	var hours = Math.floor( minutes / 60 );
	minutes -= hours * 60;
	return hours + ":" + inZeros(minutes,2) + ":" + inZeros(seconds,2);
}

function NbQuotingFormatter(elem,record,column,data)
{
  elem.innerHTML = '<nobr>' + HtmlQuote(data) + '</nobr>';
}

function QuotingFormatter(elem,record,column,data)
{
  elem.innerHTML = HtmlQuote(data);
}

// this function is for attaching an event handler
// to an ActiveX in IE.
// IE-9 has attachEvent, but IE-11 does not.
// function f needs to be not inline
// object needs to have an id
function IE_event( object, eventname, f )
{
	if (object.attachEvent)
	{
		object.attachEvent(eventname,f);
	} else
	{
		// this is for IE 11
		var script = document.createElement('script');
		script.setAttribute('for', object.id );
		var ft = f.toString();
		var params = ft.match( /\(.*\)/ );
		// the part after function but before (
		// after function, any amount of space,
		// but then an area (will be [1]) that does not contain
		// either whitespace or a brace
		var functionName = ft.match( /^function\s+([^\s(]*)/ )[1];
		script.event = eventname + params;
		script.appendChild( document.createTextNode(functionName+params+";") );
		document.body.appendChild( script );
	}
}

function RegSysChangeSync()
{
	addData('act','sysChangeReported');
	ActionSubmit();
}

function RegSysChange()
{
	try{
		YAHOO.util.Connect.asyncRequest('POST', getRootUrl(), {}
    , 'act=sysChangeReported&SessionToken=' + encodeURIComponent(SessionToken) ); 
	} catch($e)
	{
		alert($e);
	}
	return true;
}

var styleElemCategoryColors = null;

function applyCategoryColors()
{
  try
  {
    if (styleElemCategoryColors!=null)
    {
      elem = styleElemCategoryColors;
      elem.parentNode.removeChild( elem );
    }
    var elem = document.createElement("style");
    styleElemCategoryColors = elem;
    elem.appendChild( document.createTextNode('') );
    document.head.appendChild( elem );
    var sheet = elem.sheet;
    for (ix=1;ix<=10;ix++)
    {
      var catCol = catColors[ix-1];
      var darkerCol = '';
      var s = '';
      for (j=0;j<3;j++)
      {
        var x = parseInt(catCol.substr(j*2,2),16);
        x -= 90;
        if (x<0) x=0;
        x = x.toString(16);
        if (x.length==1) x = '0' + x;
        darkerCol += x;
      }
      sheet.insertRule("body span.cat"+ix+" { background-color: #"+catCol+"; }",0);
      sheet.insertRule("body span.cat"+ix+" { border-color: #"+darkerCol+"; }",0);
    }
  } catch (e)
  {
    //alert( e);
  }
}

function RemoveClassElems(cls)
{
  var list = Dom.getElementsByClassName(cls,null,null);
  for (ix in list)
  {
    list[ix].parentNode.removeChild( list[ix] );
  }
}

function AddStageToForm(stage)
{
  var inp = document.createElement('input');
  inp.setAttribute('type','hidden');
  inp.setAttribute('name','stage');
  inp.setAttribute('value',stage);
  window.document.forms[0].appendChild( inp );
}

function InitOnlyLoginPage()
{
  RemoveClassElems('usr');
  RemoveClassElems('pwd');
  AddStageToForm('initlogin');
}

function InitUsrSelLoginPage()
{
  RemoveClassElems('pwd');
  AddStageToForm('usrsel');
}


