  var myColumnDefs = [];
	var myDataSource;
	var myAsyncDataSource;
	var myDataTable;
  var dialog_MassDel = null;
  var dialog_SetCallEncryptionPwd = null;
  var dialog_GetCallEncryptionPwd = null;
  var dialog_SetEncryptionNumbers = null;
  var progressBar;

	var mediaRecordingId = -1;
	
	var colpos = ['playlink','flags','startdate','length','waittime','direction'
		,'category','notes','notes2','notes3','notes4','notes5'
		,'data1','data2','data3','data4','data5'
		,'remote','rname'
		,'connected','cname'
		,'direction2'
		,'local','lname'
		,'linenr'
		,'remote2','local2'
		,'agent'
    ,'tenant'
		,'checksum'
		,'rem', 'recorder'
		];
	var colposmap = {};

	var allAsync = false;
	var refreshTimer = null;

	function addIf(colname, arr, obj)
	{
    // the condition must remain showcols,
    // otherwise a problem occurs with colposmap
		if (showcols[colname])
		{
			if (typeof(colposmap[colname])=='undefined') return;
			arr[ colposmap[colname] ] = obj;
		}
	}
	
  function IsColVis(key)
  {
    for (ix in myColumnDefs)
    {
      if (myColumnDefs[ix].key==key) return true;
    }
    return false;
  }

  function CanSort(col)
  {
    if (CallerReceiver)
		{
      return false;
    } else
    {
      return true;
    }
  }
  
  function GetLabel(col)
  {
		if (CallerReceiver)
		{
			if (col=='rname') return "<%Cols.receiverName%>";
      if (col=='rid') return "<%Cols.receiverID%>";
      if (col=='rip') return "<%Cols.receiverIP%>";
      if (col=='lname') return "<%Cols.callerName%>";
      if (col=='lid') return "<%Cols.callerID%>";
      if (col=='lip') return "<%Cols.callerIP%>";
		} else
		{
			if (col=='rname') return "<%Cols.rname%>";
      if (col=='rid') return "<%Cols.remoteID%>";
      if (col=='rip') return "<%Cols.remoteIP%>";
      if (col=='lname') return "<%Cols.lname%>";
      if (col=='lid') return "<%Cols.localID%>";
      if (col=='lip') return "<%Cols.localIP%>";
    }
	}

  var PM_DOWNLOAD = 2;
  var PM_PLAY = 2048;
  var PM_DELETE = 4;
  var PM_NOTES = 16;
  var PM_EDITNAMES = 64;
	var Event = YAHOO.util.Event;
	var Dom = YAHOO.util.Dom;
	var PlayBtn;
	var DownloadBtn;
	var DownloadScreenBtn;
	var EmailBtn;
	var DeleteBtn;
	var RecycleBtn;
  var ListingBtn = null;
  var MassDeleteBtn = null;
  var MassDeleteRecycleBtn = null;

  var UserOrAllBtnGroup = null;

  function SetPage(startvalue)
  {
    var mainform = document.getElementById("mainform");
    addData('page',startvalue);
    SearchSubmit();
  }

	function makeColPosMap()
	{
		cnt = 0;
		for (ix in colpos)
		{
			colname = colpos[ix];
			if (showcols[colname]==false) continue;
			colposmap[colname] = cnt;
			cnt ++;
		}
	}

// the rest was below main function

  function CellClick(evt)
  {
    var colkey = myDataTable.getColumn( evt.target ).key;
    var pm = myDataTable.getRecord( evt.target ).getData('pm');
    var allowed = true;
    if (colkey=='notes' || colkey=='notes2')
    {
      if ( ! (pm&PM_NOTES) )
      {
        allowed = false;
      }
    }
    if (colkey=='rname' || colkey=='lname')
    {
      if ( ! (pm&PM_EDITNAMES) )
      {
        allowed = false;
      }
    }

    if (allowed)
    {
      myDataTable.onEventShowCellEditor(evt);
    }
  }

	function doPlay()
	{
     var selrows = myDataTable.getSelectedRows();
     if (selrows.length==0) return;
     if (selrows.length==1)
     {
       var record = myDataTable.getRecord(selrows[0]);
       var id = record.getData("id");
       var fn = record.getData("filename");
       var flags = record.getData("flags");
       GenPlay(id,fn,flags);
		 } else
		 {
			 openurl("getcall/calls.vidi?id="+GetRecordingsIds());
		 }
  }
  
  function CallEncryptedRecordingsSelected()
  {
    var selrows = myDataTable.getSelectedRows();
    for(var i = 0; i < selrows.length;i++)
    {
      var flags = myDataTable.getRecord(selrows[i]).getData('flags');
      if(flags & 2048)
      {
        return true;
      }
    }

    return false;
  }

	function GetRecordingsIds()
	{
     var selrows = myDataTable.getSelectedRows();
     var ids = '';
     var first = true;
     for (var i=0;i<selrows.length;i++)
     {
       if (!first) ids += ','
       first = false;
       ids += myDataTable.getRecord(selrows[i]).getData("id");
     }
     return ids;
  }
	
	function GetRecordingsSupervisor()
	{
     var selrows = myDataTable.getSelectedRows();
     return myDataTable.getRecord(selrows[0]).getData("supervisorid");
     
  }

  function doEmail()
  {
     var selrows = myDataTable.getSelectedRows();
     if (selrows.length==0) return;
     addData('act','email');
     addData('call-ids',GetRecordingsIds());
     ActionSubmit();

     //if (playlink=="") return;
     //startplay(playlink+"&d=1");
  }

	function change_filename_extension(fn,ext)
	{
		var ix = fn.lastIndexOf('.');
		fn = fn.substr(0,ix);
		return fn + ext;
	}
	
	function doDownloadScreen()
	{
     var selrows = myDataTable.getSelectedRows();
     if (selrows.length==0) return;
     var playlink = myDataTable.getRecord(selrows[0]).getData("playlink");
     if (playlink=="") return;
     if (selrows.length==1)
     {
	     var record = myDataTable.getRecord(selrows[0]);
	     var id = record.getData("id");
	     var fn = record.getData("filename");
			 fn = change_filename_extension(fn,'.wmv');
			 openurl('getcall/' + fn + '?id=' + id + "&d=1&scr=1");
		 } else
		 {
			 openurl("getcall/calls.zip?id="+GetRecordingsIds()+"&d=1&scr=1");
		 }
  }

function doDownload()
{
   var selrows = myDataTable.getSelectedRows();
   if (selrows.length==0) return;
   if (selrows.length==1)
   {
     var record = myDataTable.getRecord(selrows[0]);
     var id = record.getData("id");
     var fn = record.getData("filename");
     var flags = record.getData("flags");
     if(flags & 2048)
     {
      if(call_encryption_available)
      {
        DownloadEncrypted('getcall/' + fn + '?id=' + id + "&d=1", id, fn);
      }
      else
      {
        if(location.protocol != "https:")
        {
          alert("<%Web.CallEncryptNoDownload%> <%Web.CallEncryptHTTPSRequired%>");
        }
        else
        {
          alert("<%Web.CallEncryptNoDownload%> <%Web.CallEncryptBrowser%>");
        }
      }
     }
     else
     {
      openurl('getcall/' + fn + '?id=' + id + "&d=1");
     }
   } else
   {
    var encryptedRows = [];
    var ids = '';
    var first = true;
    for (var i=0;i<selrows.length;i++)
    {
      var record = myDataTable.getRecord(selrows[i]);
      var flags = record.getData("flags");
      
      if(flags & 2048)
      {
        encryptedRows.push(record);
      }
      else
      {
        if (!first) ids += ','
        first = false;
        ids += record.getData("id");
      }
    }

    if(ids.length > 0)
    {
      openurl("getcall/calls.zip?id="+ids+"&d=1");
    }

    if(encryptedRows.length > 0)
    {
      if(call_encryption_available)
      {
        DownloadMultipleEncrypted(encryptedRows);
      }
      else
      {
        if(location.protocol != "https:")
        {
          alert("<%Web.CallEncryptNoDownload%> <%Web.CallEncryptHTTPSRequired%>");
        }
        else
        {
          alert("<%Web.CallEncryptNoDownload%> <%Web.CallEncryptBrowser%>");
        }
      }
    }
  }
}


  function doDelete()
  {
     var selrows = myDataTable.getSelectedRows();
     if (selrows.length==0) return;
     var answer = confirm("<%~Web.ConfirmDelRecording%>");
     if (answer)
     {
        addData("act","del-record");
        addData("del-ids",GetRecordingsIds());
        ActionSubmit();
     }
  }

  function EnsureMassDelDialog()
  {
    if(dialog_MassDel == null)
    {
      function okHandler()
      {
        var err = false;

        if(!Dom.get("massdel-ack").checked)
        {
          err = true;
          Dom.addClass(Dom.get("massdel-ack-label"), "err");
        }

        if(checkMassDelSearchEmpty() && !Dom.get("massdel-ack-no-filter").checked)
        {
          err = true;
          Dom.addClass(Dom.get("massdel-ack-no-filter-label"), "err");
        }

        if(checkMassDelSearchModified() && !Dom.get("massdel-ack-unapplied-filter").checked)
        {
          err = true;
          Dom.addClass(Dom.get("massdel-ack-unapplied-filter-label"), "err");
        }

        if(err)
        {
          return;
        }

        addData("act", "mass-del-record");
        ActionSubmit();
      }

      function closeHandler()
      {
        this.hide();
        Dom.get('massdel-ack').checked = false;
        Dom.removeClass(Dom.get('massdel-ack-label'), 'err');

        Dom.get('massdel-ack-no-filter').checked = false;
        Dom.removeClass(Dom.get('massdel-ack-no-filter-label'), 'err');

        Dom.get('massdel-ack-unapplied-filter').checked = false;
        Dom.removeClass(Dom.get('massdel-ack-unapplied-filter'), 'err');
      }

      Dom.get('dialog_ConfirmMassDelete').style.display = '';
      dialog_MassDel = new YAHOO.widget.Dialog("dialog_ConfirmMassDelete",
      {
        modal : true,
        visible: false,
        constraintoviewport : true,
        fixedcenter : true,
        draggable: true,
        buttons : [ { text:"<%Main.OK%>", handler:okHandler, isDefault:true },
 								      { text:"<%Main.Cancel%>",handler:closeHandler } ]
      });
      dialog_MassDel.render();
    }
  }

  function doMassDelete()
  {
    EnsureMassDelDialog();
    
    if(checkMassDelSearchEmpty())
    {
      Dom.removeClass(Dom.get("massdel-ack-no-filter-table"), "invis");
    }
    else
    {
      Dom.addClass(Dom.get("massdel-ack-no-filter-table"), "invis");
    }

    if(checkMassDelSearchModified())
    {
      Dom.removeClass(Dom.get("massdel-ack-unapplied-filter-table"), "invis");
    }
    else
    {
      Dom.addClass(Dom.get("massdel-ack-unapplied-filter-table"), "invis");
    }

    dialog_MassDel.show();
  }

  function isValidSearchKey(elem)
  {
    var ignore = ["data", "page", "sd", "sk"];
    
    for(var ix = 0; ix < ignore.length; ++ix)
    {
      if(elem.startsWith(ignore[ix])) return false;
    }
    return true;
  }

  function checkMassDelSearchEmpty()
  {
    var cur_search_str = window.location.search.substr(1);
    var cur_search = cur_search_str != "" ? cur_search_str.split('&') : [];
    cur_search = cur_search.filter(isValidSearchKey);

    return cur_search.length == 0;
  }

  function checkMassDelSearchModified()
  {
    var cur_search_str = window.location.search.substr(1);
    var cur_search = cur_search_str != "" ? cur_search_str.split('&') : [];
    
    cur_search = cur_search.filter(isValidSearchKey);

    var cur_input_all = GetCallsRequest().substr(1).split('&');
    var cur_input = cur_input_all.filter(isValidSearchKey);

    if(cur_input.length != cur_search.length) return true;

    cur_input.sort();
    cur_search.sort();

    for(var ix = 0; ix < cur_input.length; ++ix)
    {
      if(cur_input[ix] !== decodeURIComponent(cur_search[ix])) return true;
    }

    return false;
  }

  function doMassRecycle()
  {
    addData("act", "mass-rec-record");
    ActionSubmit();
  }

  function doRecycle()
  {
     var selrows = myDataTable.getSelectedRows();
     if (selrows.length==0) return;
  	 addData("act","rec-record");
		 addData("rec-ids",GetRecordingsIds());
		 ActionSubmit();
  }

  function CheckBtnEnabled()
  {
        var play = false;
        var dwn = false;
        var del = false;
        var screenrec = false;
        if (myDataTable.getSelectedRows().length>0)
        {
          var row = myDataTable.getSelectedRows()[0];
          var record = myDataTable.getRecord( row );
					if (record==null) return;
          var pm = record.getData('pm');
					var flags = record.getData('flags');
          var arch = record.getData('arch')
					|| ( (flags&4)!=0 && LoadDelBackup);
          var flags = record.getData('flags');
          var id = record.getData("id");
          dwn = (pm & PM_DOWNLOAD) && arch;
          play = (pm & (PM_PLAY|PM_DOWNLOAD)) && arch	&& (flags&8)==0;
          del = pm & PM_DELETE;
          screenrec = ((record.getData('flags')&2)!=0) && dwn;
        }

        PlayBtn.set("disabled",!play);
        DownloadBtn.set("disabled",!dwn);
        if (EmailBtn!=null)
        {
          EmailBtn.set("disabled",!dwn);
        }
        if (DeleteBtn!=null)
        {
          DeleteBtn.set("disabled",!del);
        }
        if (RecycleBtn!=null)
        {
          RecycleBtn.set("disabled",!del);
        }
        if (DownloadScreenBtn!=null)
				{
					DownloadScreenBtn.set("disabled",!screenrec);
				}

				// hook
				if (typeof(CheckBtnEnabledExtra)!='undefined') CheckBtnEnabledExtra(play);
  }

  function SearchPrepare()
	{
		SearchPrepareGeneral();

    if (showownswitch)
    {
      var own = UserOrAllBtnGroup.getButton(0).get('checked')?1:0;
      if (own==1)
      {
        addData('own',own);
      }
    }

    addData('sk',sortkey);
    addData('sd',SortDirStr(sortdir));

    if (typeof(SearchPrepareExtra)!='undefined') SearchPrepareExtra();
  }
	
  function SearchSubmit()
  {
		if (allAsync)
		{
			var callbackobj = {
				success : asyncSuccess
			,	failure : asyncFailure
			, scope   : myDataTable
			};
			myDataSource.sendRequest(GetCallsRequest(),callbackobj);
		} else
		{
			SearchPrepare();
			// nothing has changed, so no action
			NoActionSubmit();
		}
	}

	function screenplay(id)
	{
    window.open( 'viewscr.php?id=' + id , 'screenrecording_playback' 
    , 'width='+(screen.width-20)
    + ',height='+(screen.height-105)
    + ',resizable=1'
    );
	}

	function viewTranscription(id)
	{
    window.open( 'viewtranscript.php?id=' + id , 'transcript_view');
	}
	
	function GetRecordForId(id)
	{
		if (id==null) return null;
		// get the record for this ID
		// first easy one, check the selection
		if (myDataTable.getSelectedRows().length>0)
		{
			var row = myDataTable.getSelectedRows()[0];
			var selectedRecord = myDataTable.getRecord( row );
			if (selectedRecord.getData("id")==mediaRecordingId)
			{
				return selectedRecord;
			}
		}
		// if needed
		// check whole table
		var records = myDataTable.getRecordSet();
		for (var i=0;i<records.getLength();i++)
		{
			var record = records.getRecord(i);
			if (record.getData("id")==mediaRecordingId)
			{
				return record;
			}
		}
		return null;
	}
	
	function SetMediaRecordingId( id )
	{;
		if (mediaRecordingId != id)
		{
			mediaRecordingId = id;
			mediaRecord = GetRecordForId( mediaRecordingId );
			StopAudio();
			if(wavesurfer){
				destroyWave();
				ShowMarkers();
			}else{
				prevFile="";
				ShowMarkers();
			}
		} else {
			mediaRecord = GetRecordForId( mediaRecordingId );
			ShowMarkers();
		}
	}
	
	function startplay(id,filename,flags)  {
		SetMediaRecordingId( id );
		GenPlay(id,filename,flags);
	}
	
  function openurl(url)
  {
    window.location.href = url;
  }

  function onExportCSV()
  {
		addData('export','csv');
		SearchPrepare();
		// nothing has changed, so no action
		NoActionSubmit();
		clearData();
  }
  
  function onExportXLSX()
  {
    addData('export', 'xlsx');
    SearchPrepare();
    NoActionSubmit();
    clearData();
  }
	
	function GetCallsRequest()
	{
		SearchPrepare();
		// .substr(1) for POST
    var req = GetSubmitUrl('');
		req += '&data=calls';
		if (isDataDefined('page')==false)
		{
			req += '&page='+page;
		}
		clearData();
    return req;
	}
	
	function rebuildNav(meta)
	{
		/*
		var nav1 = Dom.get('nav1');
		while (nav1.firstChild)
		{
			nav1.removeChild(nav1.firstChild);
		}
		*/
		
		//var pages = meta.call_count / meta.pagesize;
		
		var list = Dom.getElementsByClassName('callcnt',null,'nav1');
		for (ix in list)
		{
			var plus = '';
			if (meta.atleast==1) plus = '+';
			var t = meta.call_count + plus + " <%~Main.recordings%>";
			list[ix].innerHTML = HtmlQuote(t);
		}
		
		/*
		for (var pagerIx=1;pagerIx<=2;pagerIx++)
		{
			pagers[pagerIx].setRowsPerPage( meta.pagesize, true );
			pagers[pagerIx].setTotalRecords( meta.call_count, true );
			pagers[pagerIx].setPage( meta.pagenow + 1, true  );
		}
		*/

	}
	
	function dataSourceResponseParsed(oArg)
	{
		//alert( YAHOO.lang.dump( oArg.response.meta ) );
		rebuildNav( oArg.response.meta );
		SelectionChanges();
	}

	function GetRefreshRequest()
	{
		var req = '?data=calls';
		for (ix in searchobj)
		{
			req += '&' + ix + "=" + encodeURIComponent(searchobj[ix]);
		}
		req += '&page='+page;
		req += '&sk='+sortkey;
		req += '&sd='+SortDirStr(sortdir);
		if (typeof(isRecycleBin)=='undefined') ;
		else
		{
			req += '&rb=1';
		}
    return req;
	}
	
	function autoRefreshTimer()
	{
		if (RefreshCallList)
		{
			refreshTimer = setTimeout(autoRefreshTimer,RefreshCallListInterval*1000);
		}
		if (myDataTable.anyEditorActive)
		{
			return;
		}
		/*
		// showing this too often, makes one nervous...
		Dom.get('async-progress').innerHTML
			= '<img src="p/yui/assets/skins/sam/wait.gif" alt="loading">';
		*/
		var callbackobj = {
			success : asyncSuccess
		,	failure : asyncFailure
		, scope   : myDataTable
		};
		myAsyncDataSource.sendRequest(GetRefreshRequest(),callbackobj);
	}
	
	function asyncSuccess(oRequest, oParsedResponse)
	{
		Dom.get('async-progress').innerHTML = '';
		if (myDataTable.anyEditorActive)
		{
			return;
		}
		// already called elsewhere: rebuildNav( oParsedResponse.meta );
		var ids = GetSelectedIds();
		this.onDataReturnReplaceRows.apply(this, arguments );
		SetSelectedIds(ids);
	}
	function asyncFailure()
	{
		Dom.get('async-progress').innerHTML
			= '<img src="p/img/inactive.png" alt="failed" title="Refresh failed">';
		RefreshCallList = false;
		clearTimeout( autoRefreshTimer );
	}

  function AssignToTenant(a,b,tenantId)
  { 
    var selrows = myDataTable.getSelectedRows();
    if (selrows.length==0)
    {
      alert("<%~Tenancy.NoRecSel%>");
      return;
    }

    if(CallEncryptedRecordingsSelected())
    {
      alert("Cannot reassign encrypted calls to another tenant");
      return;
    }

    if (tenantId==0)
    {
      if (!confirm("<%~Tenancy.UnassignRecQ%>")) return;
    } else
    {
      var tenantName = tenants[tenantId];
      if (!confirm( ("<%~Tenancy.AssingRecQ%>").replace("{0}",tenantName) )) return;
    }
    addData("act","tn-assign-recs");
    addData("tenantid",tenantId);
    addData("recids",GetRecordingsIds());
    ActionSubmit();
  }
  
	function SetSelectedIds(ids)
	{
		// remove previous selection (might be even invalid,
		// because of reload from external source)
		myDataTable.unselectAllRows();
		var records = myDataTable.getRecordSet();
		for (var i=0;i<records.getLength();i++)
		{
			var record = records.getRecord(i);
    	if (ids[ record.getData('id') ])
    	{
				myDataTable.selectRow(i);
			}
		}
	}

	function GetSelectedIds()
	{
		var selrows = myDataTable.getSelectedRows();
		var ids = {};
		for (ix in selrows)
		{
     var record = myDataTable.getRecord(selrows[ix]);
     if (record==null) continue;
     var id = record.getData("id");
		 ids[id] = 1;
		}
		return ids;
	}
	
	function SelectionChanges()
	{
		CheckBtnEnabled();
		
		var selectedRecordingId = null;
		
		if (myDataTable.getSelectedRows().length>0)
		{
			var row = myDataTable.getSelectedRows()[0];
			var selectedRecord = myDataTable.getRecord( row );
			if (selectedRecord==null) return;
			selectedRecordingId = selectedRecord.getData("id");
		}

		SetMediaRecordingId( selectedRecordingId );
		
	}

        function NonBreakFormatter(elem,record,column,data)
        {
					elem.innerHTML = dontbreak(data);
				}

				function LineFormatter(elem,record,column,data)
				{
					if (data=='0') elem.innerHTML = '';
          else elem.innerHTML = data;
				}

				function NullFormatter(elem,record,column,data)
				{
					if (data==null) elem.innerHTML = '';
          else elem.innerHTML = data;
				}

        function TenantFormatter(elem,record,column,data)
        {
					var key = column.key;
					var tenantid = record.getData(key);
          var data = '';
          if ( typeof( tenants[tenantid] ) == 'string')
          {
            data = tenants[tenantid];
          }
					elem.innerHTML = dontbreak(HtmlQuote(data));
        }
        
        function MyFormatter(elem,record,column,data)
        {
					var key = column.key;
					data = record.getData(key);
					if (data==null) data = '';
					elem.innerHTML = dontbreak(HtmlQuote(data));
					if (key=='local' || key=='remote')
					{
	          var full = record.getData(key+'full');
	          if (full!='' && full!=data)
	          {
	            elem.setAttribute("title",full);
	          }
					}
				}

				function dontbreak(text)
				{
					//return text.replace(/ /g,'&nbsp;');
					return '<nobr>' + text + '</nobr>';
				}

        function NotesFormatter(elem,record,column,data)
        {
					/*
					is now done using CSS
          var maxlen = 30;
          if (data.length>maxlen)
          {
            elem.innerHTML = dontbreak(HtmlQuote(data.substring(0,28))+"..");
            elem.setAttribute("title",data)
          } else {
            elem.innerHTML = dontbreak(HtmlQuote(data));
          }
					*/
					elem.innerHTML = HtmlQuote(data);
          if (data.length>15)
          {
						elem.setAttribute("title",data)
					}
        }

        function ioformat(elem,record,column,data)
        {
          var t = '';
					if (data==0) {
            t += '<img src="p/img/incoming.png" alt="<%Web.Incoming%>" title="<%Web.Incoming%>">';
          }
          if (data==1) {
            t += '<img src="p/img/outgoing.png" alt="<%Web.Outgoing%>" title="<%Web.Outgoing%>">';
          }
          if (data==2) {
            t += '<img src="p/img/internal.png" alt="<%Web.Internal%>" title="<%Web.Internal%>">';
          }
          elem.innerHTML = t;
        }
				
        function vidiStrPad(prefix,data,len)
        {
          var newdata = '' + data;
          while (newdata.length<len)
          {
            newdata = prefix + newdata;
          }
          return newdata;
        }

				function waittimeFormat(elem,record,column,data)
				{
					if (data==-1) elem.innerHTML = '';
          else
          {
            var t = formatDurationLong(data);
            elem.innerHTML = t;
          }
				}
        
				function durationFormat(elem,record,column,data)
				{
					if (data==-1) elem.innerHTML = '';
          else
          {
            var t = formatDurationLong(data);
            if (timeformatix==1)
            {
              var durms = record.getData('lenms');
              if (durms!=null)
              {
                t += '.' + vidiStrPad('0',durms,3);
              }
            }
            elem.innerHTML = t;
          }
				}
				
				function dir2format(elem,record,column,data)
        {
          var LR = false;
					var t = '';
					var dir = record.getData('direction');
					if (!CallerReceiver )
					{
						if (dir==0) LR = true;
					}
					if (LR) {
            t += '<img src="p/img/dir-lr.png" alt="=&gt;" title="=&gt;">';
          } else
					{
						t += '<img src="p/img/dir-rl.png" alt="&lt;=" title="&lt;=">';
					}
          elem.innerHTML = t;
        }

				function CategoryFormat(elem,record,column,data)
				{
					if (data=="") return;
					var idata = parseInt(data,10);
					if (idata>0)
					{
						var t = categoryList[idata].label;
						elem.innerHTML = '<span class="catbox cat'+data+'" title="'+HtmlQuote(t)+'"></span>';
					} else
					{
						elem.innerHTML = '';
					}
				}

				function FlagsFormat(elem,record,column,data)
				{
          var imgs = [];
					if (data & 4096)
					{
						imgs.push( '<img title="Pending delete" src=\"p/img/delete-white.png\"/>' );
					}
          if(data & 2048)
          {
            imgs.push( '<img title="Tenant call encryption" src=\"p/img/lock.png\"/>' );
          }
					if (data&512)
					{
						var id = record.getData('id');
						var t = "<img title=\"<%~Web.Transcript%>\" src=\"p/img/transcription.png\"/>";
						if (embedPlayer || audio5 || wavesurfer)
						{
							t = '<a href="#" onclick="viewTranscription('+id+'); return false;">'
							+ t + '</a>';
						}
						imgs.push( t );
					}
					if(data&64)
					{
						imgs.push( '<img title="Missed call" src=\"p/img/delete-white.png\"/>' ) ;
					}
					if (data&32)
					{
						imgs.push( '<img title="Channel limit reached" src=\"p/img/dialog-warning.png\"/>' );
					}
					if (data&16)
					{
						imgs.push( '<img title="encrypted" src=\"p/img/lock.png\"/>' );
					}
					if (data&8)
					{
						imgs.push( '<img title="failed to convert (codec?)" src=\"p/img/dialog-error.png\"/>' );
					}
					if (data&4)
					{
						imgs.push( '<img title="auto-deleted" src=\"p/img/image-missing.png\"/>' );
					}
					if (data&2)
					{
						var id = record.getData('id');
						var t = '<img title="screen recording" src=\"p/img/video-display.png\"/>';
						if (embedPlayer || audio5 || wavesurfer)
						{
							t = '<a href="#" onclick="screenplay('+id+'); return false;">'
							+ t + '</a>';
						}
						imgs.push( t );
					}
					if (data&1)
					{
						imgs.push( '<img title="not completed normally" src=\"p/img/dialog-warning.png\"/>' );
					}
					if (record.getData('arch')==0 && ((data&100)==0))
					{
						imgs.push( '<img title="missing" src=\"p/img/dialog-error.png\"/>' );
					}
					
					var markers = record.getData('markers');
					var markerCount = 0;
					for (ix in markers)
					{
						markerCount++;
					}
					if (markerCount>0)
					{
						imgs.push( "<img title=\"<%Web.Annotation%> ("+markerCount+"x)\" src=\"p/img/annotation.png\"/>" );
						
					}
          
					// imgs.join('&nbsp;') would increase row height
          var h = imgs.join('');
          if (to_config)
          {
            var pol = record.getData('retention');
            if (typeof(pol)!='undefined')
            {
              if (pol!=null) h += ' [' + pol + ']';
            }
          }
					
					elem.innerHTML = '<nobr class="imgsm">'+h+'</nobr>';
				}
				
        function PlayFormat(elem,record,column,data)
        {
          if (data!="")
          {
            var pm = record.getData('pm');
            var flags = record.getData('flags');
            var arch = record.getData('arch');
            var id = record.getData('id');
            var fn = record.getData('filename');
            var flags = record.getData('flags');
            if ( (pm & (PM_PLAY|PM_DOWNLOAD))
						&& ((arch!=0) || ( (flags&4)!=0 && LoadDelBackup) )
						&& (flags&8)==0)
            {
							var ablk = '';
							if (embedPlayer || audio5 || wavesurfer)
							{
								ablk = '<a href="#" onclick="startplay( ' + id + ' , \'' + fn + '\'' + ' , ' + flags + ' ); return false;">';
								//alert(extra);
							} else
							{
              	ablk = "<a href=\"getcall/" + fn + "?id=" + id + "\" >";
       				}
              elem.innerHTML =
              ablk
              + "<img width=\"20\" height=\"20\" alt=\"<%Web.Play%>\" title=\"<%Web.Play%>\" src=\"p/img/playpause.png\"/>"
              + "</a>";
            } else {
              elem.innerHTML = '';
            }
          }
        }

var dialogConfGrid = null;

function ensureDialogConfGrid()
{
  if (dialogConfGrid!=null) return;
  var container = Dom.get('column-selector');
  for (ix in colpos)
  {
    var colkey = colpos[ix];
    if (showcols[ colkey ] == 0) continue;
    
    colkey = convertColKey( colkey );
    
    var div = document.createElement('div');
    div.style = "padding:0.2em";

    var cb = document.createElement('input');
    cb.setAttribute('type','checkbox');
    cb.setAttribute('id','colsel_' + colkey );
    div.appendChild(cb);
    
    cb.checked = true;
    Event.on(cb,'change',function(a,colkey)
    {
      //alert('changed ' + obj.colkey + ' ' + this.checked);
      if (this.checked) myDataTable.showColumn(colkey);
      else myDataTable.hideColumn(colkey);
      
    },colkey);
    
    var lbl = document.createElement('label');
    lbl.setAttribute('for','colsel_' + colkey );
    lbl.style = "margin-left: 0.5em;";
    var header = '';
    if (typeof(colheaders[ colpos[ix] ])!='undefined')
    {
      header = colheaders[ colpos[ix] ];
    }
    var tobj = document.createTextNode( header );
    //    + ' ---(' + colkey );
    lbl.appendChild(tobj);
    div.appendChild( lbl );
    
    container.appendChild( div );
  }
  
  dialogConfGrid = new YAHOO.widget.SimpleDialog("dialog_ConfGrid", 
  { width: "30em"
  , visible: false
  , modal: true
  , buttons: [ ]
  , fixedcenter: true
  , constrainToViewport: true
  } );
  dialogConfGrid.render();
  dialogConfGrid.subscribe('hide', newColumnConfig );
  Dom.get('dialog_ConfGrid').style.display = '';
}

function OnConfGrid()
{
  ensureDialogConfGrid();
  var colset = myDataTable.getColumnSet();
  for (ix in colset.keys)
  {
    var col = colset.keys[ix];
    var elem = Dom.get('colsel_' + col.key );
    elem.checked = !col.hidden;
  }
  dialogConfGrid.show();
}

function newColumnConfig()
{
  var colList = [];
  var colset = myDataTable.getColumnSet();
  for (ix in colset.keys)
  {
    var col = colset.keys[ix];
    if (col.hidden) continue;
    var d = col.key;
    if (col.resizeable && col.width!=null)
    {
      d += ':' + col.width;
    }
    colList.push( d );
  }
  var colCfg = colList.join(', ');
  if (colCfg == dbColCfg)
  {
    // the same, nothing to do
    return;
  }
  
  // send async to server and store
  var callbackInfo = 
  { success : function(o)
    {
      try
      {
        var ret = YAHOO.lang.JSON.parse(o.responseText);
        if (ret.errcode==0)
        {
          dbColCfg = colCfg;
        } else
        {
          alert('Display setting edit failed. Error code: '+ret.errcode);
        }
      } catch(e)
      {
        alert('Display setting edit failed. Invalid response: ' + e); 
      }
    }
  , failure : function()
    {
      alert('Failed to contact server.');
    }
  };
  
  YAHOO.util.Connect.asyncRequest
  ( 'POST'
  , document.URL
  , callbackInfo
  , 'act=edit-display'
    + '&cols=' + encodeURIComponent( colCfg )
    + '&SessionToken=' + encodeURIComponent(SessionToken)
  );      
                      
}

function convertColKey( colkey )
{
  if (colkey=='rem') colkey = 'remoteid';
  if (colkey=='checksum') colkey = 'chk';
  return colkey;
}

function applyColumnCfg( colCfg )
{
  if (colCfg==null || colCfg=='') return;
  var items = colCfg.split(',');
  var hasCol = [];
  for (ix in colpos)
  {
    var colkey = convertColKey( colpos[ix] );
    hasCol[ colkey ] = false;
  }
  
  var newColDefs = [];

  for (ix in items)
  {
    var d = items[ix].trim();
    var d_items = d.split(':');
    var key = d;
    if (d_items.length==2)
    {
      key = d_items[0];
    }
    hasCol[ key ] = true;
    
    for (ix in myColumnDefs)
    {
      if (myColumnDefs[ix].key == key)
      {
        var coldef = myColumnDefs[ix];
        if (d_items.length==2)
        {
          coldef.width = parseInt(d_items[1],10);
        }
        newColDefs.push( coldef );
        break;
      }
    }
    
  }

  // now add disabled columns, so user can enable them
  for (ix in myColumnDefs)
  {
    if (hasCol[ myColumnDefs[ix].key ]) continue;
    var coldef = myColumnDefs[ix];
    coldef.hidden = true;
    newColDefs.push( coldef );
  }
    
  myColumnDefs = newColDefs;
}

  function EnsureGetCallEncryptionPwdDialog()
  {
    if(dialog_GetCallEncryptionPwd == null)
    {
      function okHandler()
      {
        var pwd = Dom.get("UCallEncryptionPwd").value;
        Dom.get("UCallEncryptionPwd").value = "";
        this.okcallback(pwd);
        this.hide();
      }

      function closeHandler()
      {
        this.closecallback(new DOMException("Cancelled password input", "AbortError"));
        this.hide();
      }

      Dom.get('dialog_GetCallEncryptionPwd').style.display = '';
      dialog_GetCallEncryptionPwd = new YAHOO.widget.Dialog("dialog_GetCallEncryptionPwd",
      {
        modal : true,
        visible: false,
        constraintoviewport : true,
        fixedcenter : true,
        draggable: true,
        buttons : [ { text:"<%Main.OK%>", handler:okHandler, isDefault:true },
 								      { text:"<%Main.Cancel%>",handler:closeHandler } ]
      });

      Dom.get("UCallEncryptionPwd").addEventListener("keydown", function(event) {
        if(event.keyCode === 13)
        {
          okHandler.call(dialog_GetCallEncryptionPwd);
          event.preventDefault();
        }
      });

      dialog_GetCallEncryptionPwd.render();
    }
  }

  function GetCallEncryptionPwd()
  {
    EnsureGetCallEncryptionPwdDialog();
    return new Promise(function(resolve, reject){
      dialog_GetCallEncryptionPwd.okcallback = resolve;
      dialog_GetCallEncryptionPwd.closecallback = reject;
      dialog_GetCallEncryptionPwd.show();
    })
  }
    
  function TenantEncryptCall()
  {
    var IDs = GetFilteredCallIDs(function(record)
    {
      return !(record.getData('flags') & 2048);
    });

    if(IDs.length == 0)
    {
      alert("<%~Tenancy.NoRecSel%>");
      return;
    }

    addData('act', 'callencrypt');
    addData('recids', implode(',', IDs));
    ActionSubmit();
  }

  function TenantDecryptCall()
  {
    var IDs = GetFilteredCallIDs(function(record){
      return record.getData('flags') & 2048;
    });

    if(IDs.length == 0)
    {
      alert("<%~Tenancy.NoRecSel%>");
      return;
    }

    DecryptCallsReal(IDs);
  }

  function GetFilteredCallIDs(filter)
  {
    var selrows = myDataTable.getSelectedRows();
    var ids = [];
    for (var i=0;i<selrows.length;i++)
    {
      var record = myDataTable.getRecord(selrows[i]);

      if(filter(record))
      {
        ids.push(record.getData("id"));
      }
    }

    return ids;
  }