	var mediaPlayer = null;
	var mediaPlayerStatusbar = false;
	var mediaRecord = null;
	// list of markers (HTML items)
	var markerList = []; // filled by ShowMarkers
	var markerContainers = []; // filled by ShowMarkers
  var markersShown = {}; // filled by ShowMarkers
	var marker_tooltip = null;
	var marker_ct_menu = null;
	var rightClickTime = null;
	var mediaSeekTime = null;
	var dialog_annotation_edit = null;
	var markerEditId = null;
	var WMP_pb_margin = 23;

function InitPlayModule()
{
				// called during initialisation of the page
				// it creates the audio elements for playback

				if (!YAHOO.env.ua.ie)
				{
					embedPlayer = false;
				}

				if (embedPlayer)
				{
					try{
					var obj = document.createElement('object');

					var param = null;

					if (mediaPlayerStatusbar)
					{
						param = document.createElement('param');
						param.name = 'ShowStatusBar';
						param.value = 'true';
						obj.appendChild(param);
					}

					param = document.createElement('param');
					param.name = 'filename';
					param.value = ''; // To be filled by script
					obj.appendChild(param);

					obj.setAttribute('id','theplayer');
					obj.setAttribute('classid','clsid:22d6f312-b0f6-11d0-94ab-0080c74c7e95');
					obj.setAttribute('type','application/x-oleobject');
					obj.setAttribute('height',mediaPlayerStatusbar?'68':'43');

					var container = document.createElement('div');
          container.setAttribute('class','playerContainer');
					container.setAttribute('id','thePlayerContainer');
          container.appendChild(obj);

					document.body.appendChild(container);
					mediaPlayer = obj;

					if (typeof(mediaPlayer.FileName)=='undefined')
					{
          	embedPlayer = false;
            document.body.removeChild(container);
					}

					var bottomSpacer = document.createElement('div');
					bottomSpacer.setAttribute('class','pageBottomSpacer');
					document.body.appendChild(bottomSpacer);

					// all well, disable audio5
					audio5 = false;
					
					InitWmpPlayer();
					
					} catch(e)
					{
						alert(e)
					}
				} 
				
				// use wavesurfer instead of older audio5 method
				wavesurfer=audio5;
				audio5=false;
				
				if((!(window.webkitAudioContext || window.AudioContext) || LegacyAudio)){
					// switch back to older audio5, so without wavesurfer
					audio5=wavesurfer;
					wavesurfer=false;
				}
				
				if (audio5 && embedPlayer==false)
				{
					// tmp disable for case of exception
					audio5 = false;
					try{
						
						var mobj = document.createElement('audio');
						// no controls (invisible) obj.setAttribute('controls','controls');
						// we have controls of our own
						mobj.setAttribute('class','audio5player');
						
						var guiplayer1 = Dom.get('guiplayer1');
						guiplayer1.parentNode.removeChild( guiplayer1 );
						guiplayer1.style.display = 'table';

						var container = document.createElement('div');
						container.setAttribute('class','playerContainer');
						container.appendChild(guiplayer1);
						
						document.body.appendChild(container);
						mediaPlayer = mobj;

						var bottomSpacer = document.createElement('div');
						bottomSpacer.setAttribute('class','pageBottomSpacer');
						document.body.appendChild(bottomSpacer);
						
						audio5 = true;
						
						// further initialisation is done separately
						InitAudio5Player( );

					} catch(e) {
						alert(e+"\n"+e.stack)
					}
				}
				
				if (wavesurfer && embedPlayer==false)
				{
					wavesurfer = false;
					try{
						//var mobj = document.createElement('audio');
						//mobj.setAttribute('class','wavesurferplayer');

						var guiplayer1 = Dom.get('guiplayer1');
						guiplayer1.parentNode.removeChild( guiplayer1 );
						guiplayer1.style.display = 'table';

						var container = document.createElement('div');
						container.setAttribute('class','playerContainer');
						container.appendChild(guiplayer1);
						
						document.body.appendChild(container);
						//mediaPlayer = mobj;

						var bottomSpacer = document.createElement('div');
						bottomSpacer.setAttribute('class','pageBottomSpacer');
						document.body.appendChild(bottomSpacer);
						
						wavesurfer=true;
						
						InitWaveSurferPlayer();
						
					} catch(e)	{
						alert(e+"\n"+e.stack)
					}
				}
}

	function SaveAnnotationEdit()
	{
		var marker = {};
		marker.timepos = parseFloat(Dom.get('annotation_time' ).value);
		marker.descr   = Dom.get('annotation_notes').value;

		var obj_id = markerEditId;

		if (isNaN(marker.timepos) || marker.timepos>getMediaDuration())
		{
			alert('The specified time point is invalid');
			return false;
		}
		
		// edit remotely
		var callbackInfo = 
		{ success : function(o)
			{
				var ret = YAHOO.lang.JSON.parse(o.responseText);
				if (ret.errcode==0)
				{
					// delete in local array
					var markers = mediaRecord.getData('markers');
					markers[obj_id].descr = marker.descr;
					markers[obj_id].timepos = marker.timepos;

					// recreate markers (is easier)
					ShowMarkers();
				} else
				{
					alert('Failed to edit annotation. Error code: '+ret.errcode);
				}
			}
		, failure : function()
			{
				alert('Failed to contact server.');
			}
		};
		YAHOO.util.Connect.asyncRequest
		( 'POST'
		, document.URL
		, callbackInfo
		, 'act=edit-marker-async'
			+ '&id=' + markerEditId
			+ '&descr=' + encodeURIComponent(marker.descr)
			+ '&timepos=' + encodeURIComponent(marker.timepos)
      + '&SessionToken=' + encodeURIComponent(SessionToken)
		);
		
		return true;
	}

  function EnsureDialogAnnotationEdit()
  {
    if (dialog_annotation_edit==null)
    {
			function okHandler(){
				try{
					if (markerEditId==-1)
					{
						if (AnnotationAdd())
						{
							// we only know if it is OK after some time (async.)
							this.hide();
						}
					} else
					{
						if (SaveAnnotationEdit()) // save changes
						{
							this.hide();
						}
					}
				} catch(e)
				{
					alert(e+" "+e.callstack);
				}
			}
			function closeHandler(){
				this.hide();
			}

			Dom.get('dialog_annotation_edit').style.display = 'block';
			dialog_annotation_edit = new YAHOO.widget.Dialog("dialog_annotation_edit",
							{ modal: true,
								fixedcenter : true,
								visible : false,
								constraintoviewport : true,
								buttons : [ { text:"<%~Main.OK%>", handler:okHandler, isDefault:true },
											{ text:"<%~Main.Cancel%>",handler:closeHandler } ]
							});
			dialog_annotation_edit.render();
			
    }
  }

	function AnnotationTime(change)
	{
		var time = parseFloat( Dom.get('annotation_time').value );
		time = time + change * 1.0;
		Dom.get('annotation_time').value = time;
		return false;
	}

	function WMP_OpenStateChange(newstate)
	{
		if (newstate==5)
		{
			// open
			ShowMarkers();
			if (mediaSeekTime!=null)
			{
				mediaPlayer.currentPosition = mediaSeekTime;
				mediaSeekTime = null;
			}
		}
	}
	
	function WMP_Click(mousebtn,dummy,x)
	{
		if (mousebtn==2) // right-click
		{
			var duration = getMediaDuration();
			if (duration==0) return;
			var reg = YAHOO.util.Dom.getRegion( document.getElementById('thePlayerContainer') );
			var relx = x - reg.left;
			var prc = 100 * (x - reg.left - WMP_pb_margin)
				/ ( reg.right - reg.left - WMP_pb_margin*2 ) ;
			var thetime = (duration * prc / 100.0).toFixed(2);
			rightClickTime = thetime;
		}
	}
	
	function InitWmpPlayer()
	{
		var player_ct_menu = new YAHOO.widget.ContextMenu('player_ct_menu',
		{
			trigger: mediaPlayer,
			itemdata: [
					{ text: "<%~Web.AddAnnotation%>", onclick: {fn:AddMarker,obj:'add'} },
				],
			lazyload: true,
			zIndex: 10
		});
		player_ct_menu.hideEvent.subscribe(function()
		{
			rightClickTime = null;
		});
		player_ct_menu.triggerContextMenuEvent.subscribe(function()
		{
			// enable/disable whether we have a current media record
			// (whether or not a call has been selected)
			player_ct_menu.cfg.setProperty('disabled', (mediaRecord==null) );
		});
		mediaPlayer.id = 'mediaPlayerId';
		
		IE_event( mediaPlayer, 'OpenStateChange', WMP_OpenStateChange );
		
		IE_event( mediaPlayer, 'Click', WMP_Click );
		
	}
	
	function InitAudio5Player()
	{
		var waveformdiv = document.getElementById('waveform');
			waveformdiv.style.display = "none";
		var fullscreendiv = document.getElementById('guiplayer1_resizeimg');
			fullscreendiv.style.display = "none";
			
		// when clicking the play/pause button
		document.getElementById('guiplayer1_playpause')
			.addEventListener('click',function(evt)
		{
			evt.preventDefault();
			if (isNaN(mediaPlayer.duration)==true)
			{
				doPlay();
				return;
			}
			if (!mediaPlayer.paused && mediaPlayer.currentTime!=0) mediaPlayer.pause();
			else mediaPlayer.play();
		});

		mediaPlayer.addEventListener('loadedmetadata',function(evt)
		{
			// we now know the duration
			ShowMarkers();
			if (mediaSeekTime!=null)
			{
				mediaPlayer.currentTime = mediaSeekTime;
				mediaSeekTime = null;
			}
		});

		function setPauseImg()
		{
			Dom.get('guiplayer1_playimg').src = "../p/img/media-playback-pause.png";
		}
		function setPlayImg()
		{
			Dom.get('guiplayer1_playimg').src = "../p/img/media-playback-start.png";
		}
		mediaPlayer.addEventListener('playing',function()
		{
			setPauseImg();
		});
		mediaPlayer.addEventListener('ended',function()
		{
			setPlayImg();
		});
		mediaPlayer.addEventListener('pause',function()
		{
			setPlayImg();
		});
		
		mediaPlayer.addEventListener('abort',function()
		{
			timeUpdate();
			setPlayImg();
		});
		
		function timeUpdate()
		{
			var prc = 0;
			if (isNaN(mediaPlayer.duration)==false && mediaPlayer.duration!=0)
			{
				prc = Math.round(100 * mediaPlayer.currentTime / mediaPlayer.duration);
			}
			//document.getElementById('abc').innerHTML = mediaPlayer.currentTime + " " + prc;
			var gp1 = document.getElementById('guiplayer1_playprogress');
			gp1.style.width = prc + "%";
			
			var TL = document.getElementById('guiplayer1_timeLabel');
			var thetime = Math.round( mediaPlayer.currentTime , 0);
			TL.innerHTML = formatDuration(  Math.round( mediaPlayer.currentTime , 0) );
		}
		
		mediaPlayer.addEventListener('timeupdate',function()
		{
			timeUpdate();
		});
		
		document.getElementById('guiplayer1_progresspart')
			.addEventListener('mousedown',function(evt)
		{
			if (mediaRecord==null) return;
			var duration = mediaRecord.getData('length');
			if (isNaN(mediaPlayer.duration)==false)
			{
				// but use the mediaplayer duration if available,
				// since it is more accurate
				duration = mediaPlayer.duration;
			}
			var reg = YAHOO.util.Dom.getRegion( document.getElementById('guiplayer1_progressbar') );
			var relx = evt.pageX - reg.left;
			var prc = 100 * (evt.pageX - reg.left) / (reg.right - reg.left - 2) ;
			var thetime = (duration * prc / 100.0).toFixed(2);
			if (evt.button!=0) {
				// only left mouse click
				// but register position
				rightClickTime = thetime;
				return; 
			}
			if (isNaN(mediaPlayer.duration)) return;
			mediaPlayer.currentTime = thetime;
			//document.getElementById('abc').innerHTML = thetime;
			
			/*
			// maybe code can be reused for playing a more clear playing 
			// position indicator.
			var m1 = document.getElementById("marker1");
			var m1reg = YAHOO.util.Dom.getRegion( m1 );
			var m1_width = Math.round( (m1reg.right-m1reg.left)/2 );
			var m1_height = Math.round( (m1reg.bottom-m1reg.top)/2 );
			m1.style.position = "absolute";
			// next line needs better calculation
			m1.style.top = -m1_height + "px";
			m1.style.left = Math.round(relx - m1_width/2 ) + "px";
			*/
		});
		
		var player_ct_menu = new YAHOO.widget.ContextMenu('player_ct_menu',
		{
			trigger: document.getElementById('guiplayer1_progresspart'),
			itemdata: [
					{ text: "<%~Web.AddAnnotation%>", onclick: {fn:AddMarker,obj:'add'} },
				],
			lazyload: true,
			zIndex: 10
		});
		player_ct_menu.hideEvent.subscribe(function()
		{
			rightClickTime = null;
		});
		player_ct_menu.triggerContextMenuEvent.subscribe(function()
		{
			// enable/disable whether we have a current media record
			// (whether or not a call has been selected)
			player_ct_menu.cfg.setProperty('disabled', (mediaRecord==null) );
		});
		
	}
	
	
	var WaveHeight=15;
	var Region=null;
	var RegionStart=0;
	var RegionEnd=0;
	var WaveSurfer;
	var RegionsPlugin;
	var TimelinePlugin;
	var player_ct_menu;

	function wavePlay(){
		if (mediaPlayer.isPlaying()){
			mediaPlayer.pause();
		}else{
			//doPlay();
			mediaPlayer.play();
		} 
	}
	
	function setPauseImg(){
		Dom.get('guiplayer1_playimg').src = "../p/img/media-playback-pause.png";
	}
	function setPlayImg(){
		mediaPlayer.params.interact=true;
		Dom.get('guiplayer1_playimg').src = "../p/img/media-playback-start.png";
	}
	
	function setFullscreenImg(){
		Dom.get('guiplayer1_resizeimg').src = "../p/img/view-fullscreen.png";
	}
	
	function setSmallscreenImg(){
		Dom.get('guiplayer1_resizeimg').src = "../p/img/view-smallscreen.png";
	}
		
	function waveFinished(){
		setPlayImg();
		//timeupdate();
	}
		
	function resizeWave(){
		var resizeSeek=mediaPlayer.getCurrentTime();
		var resizePlay=mediaPlayer.isPlaying();
		
		if(WaveHeight==15){
			setSmallscreenImg();
			WaveHeight=150;
		}else{
			setFullscreenImg();
			WaveHeight=15;
		}
		
		var playerdiv = document.getElementById('waveform');
		playerdiv.style.height = (WaveHeight)+'px';
		mediaPlayer.params.height=WaveHeight;
		
		if(waveSurferReady){
			mediaPlayer.drawer.setHeight(WaveHeight);
			mediaPlayer.empty();
			mediaPlayer.drawBuffer();
		}
		
		if(resizeSeek!=0){
			mediaPlayer.seekTo(resizeSeek/mediaPlayer.getDuration());
			if(resizePlay){
				mediaPlayer.play();
			}
			resizeSeek=0;
			resizePlay=0;
		}
	}
	
	function destroyWave(){
		if(wavesurfer){
			prevFile="";
			waveSurferReady=false;
			RegionEnd=0;
			RegionStart=0;
			mediaPlayer.destroy();
			var TL = document.getElementById('guiplayer1_timeLabel');
			TL.innerHTML = formatDuration(0);
		}
	}
		
	function setLoadingImg(){
		Dom.get('guiplayer1_playimg').style.width = "25px";
		Dom.get('guiplayer1_playimg').style.height = "25px";
		Dom.get('guiplayer1_playimg').src = "../p/img/media-playback-loading.gif";
	}
	
	function getTimeInterval(){
		duration=parseFloat(getMediaDuration());
		if(duration==0){
			duration=1;
		}
		
		return(duration/10);		
	}
	
	var waveSurferReady=false;
	function InitWaveSurferPlayer(){
		document.getElementById('guiplayer1_resize').removeEventListener('click',resizeWave);			
		
		if(mediaPlayer!=null){			
			mediaPlayer.unAll();			
		}
		
		if(player_ct_menu!=null){
			player_ct_menu.destroy();
		}
		
		WaveSurfer = window.WaveSurfer;
		RegionsPlugin = window.WaveSurfer.regions;
		TimelinePlugin = window.WaveSurfer.timeline;
		
		function timelineFormat(a){
			return formatDuration(parseInt(a));
		}
		
		document.getElementById('guiplayer1_playpause').addEventListener('click',doPlay);
		
		mediaPlayer = WaveSurfer.create({
			waveColor: 'black',
			progressColor: 'white',
			container: '#waveform',
			cursorColor: 'white',
			hideScrollbar: 'true',
			barHeight: 2,
			height: WaveHeight,
			plugins: [
				RegionsPlugin.create({}),
				TimelinePlugin.create({
					wavesurfer: mediaPlayer,
					deferInit: true,
					timeInterval: getTimeInterval(),
					container: '#waveform-timeline',
					secondaryColor: '#919191',
					formatTimeCallback: timelineFormat
				})
			]
		});
		
		mediaPlayer.empty();
		mediaPlayer.initPlugin('regions');
		mediaPlayer.initPlugin('timeline');
		
		var progressdiv = document.getElementById('guiplayer1_progressbar');
			progressdiv.style.display = "none";		
		
		// when clicking the resize button
		document.getElementById('guiplayer1_resize').addEventListener('click',resizeWave);
		
		
		function waveReady(){
			// we now know the duration
			setPlayImg();
			mediaPlayer.enableDragSelection({
				color: 'rgba(0, 0, 255, 0.3)'
			});
			
			timeUpdate();
			if (mediaSeekTime!=null)
			{
				mediaPlayer.seekTo(parseInt(mediaSeekTime)/mediaPlayer.getDuration());
				mediaSeekTime = null;
			}
			
			
			mediaPlayer.play();
			
			waveSurferReady=true;
      // showmarkers must be done after wave surfer is set to ready
      // otherwise the duration is thought to be not known

			ClearMarkers();
      ShowMarkers();
		}
		mediaPlayer.on('ready',waveReady);
		
		
		var enableRegionPlay=true;
		function regionClick(ev){
			if(enableRegionPlay){
				mediaPlayer.params.interact=false;
				mediaPlayer.play(ev.start,ev.end);
			}
		}
		mediaPlayer.on('region-click', regionClick);
		

		function regionCreated(ev){
			mediaPlayer.params.interact=false;
			if(Region!=null){
				Region.remove();
				RegionStart=0;
				RegionEnd=0;
			}
			
			Region=ev;
			RegionStart=ev.start;
			RegionEnd=ev.end;
		}
		mediaPlayer.on('region-created', regionCreated);
		
		
		function regionUpdated(ev){
			Region=ev;
			RegionStart=ev.start;
			RegionEnd=ev.end;
		}
		mediaPlayer.on('region-update-end', regionUpdated);
		
		
		function regionMouseleave(ev){
			mediaPlayer.params.interact=true;
		}
		mediaPlayer.on('region-mouseleave', regionMouseleave);
	

		function regionDblClick(ev){
			if(mediaPlayer.isPlaying()){
				mediaPlayer.pause();
			}
			ev.remove();
			RegionStart=0;
			RegionEnd=0;
			Region=null;
		}		
		mediaPlayer.on('region-dblclick', regionDblClick);
		
		
		window.onresize = function(event) {
			var resizeSeek=mediaPlayer.getCurrentTime();
			var resizePlay=mediaPlayer.isPlaying();
      if (waveSurferReady)
      {
        mediaPlayer.empty();
        mediaPlayer.drawBuffer();
      }
      // console.log("onresize - clear");
			ClearMarkers();
			ShowMarkers();
			if(resizeSeek!=0){			
				mediaPlayer.seekTo(resizeSeek/mediaPlayer.getDuration());
				resizeSeek=0;
				resizePlay=0;
			}
		};
		
		mediaPlayer.on('finish',waveFinished);
		
		mediaPlayer.on('play',setPauseImg);
		
		mediaPlayer.on('pause',setPlayImg);
		
		mediaPlayer.on('error',setPlayImg);
		
		function timeUpdate()
		{
			//var prc = 0;
			//if (isNaN(mediaPlayer.getDuration())==false && mediaPlayer.getDuration()!=0)
			//{
			//	prc = Math.round(100 * mediaPlayer.getCurrentTime() / mediaPlayer.getDuration());
			//}
			//document.getElementById('abc').innerHTML = mediaPlayer.currentTime + " " + prc;
			//var gp1 = document.getElementById('guiplayer1_playprogress');
			//gp1.style.width = prc + "%";
			
			var TL = document.getElementById('guiplayer1_timeLabel');
			var thetime = Math.round( mediaPlayer.getCurrentTime() , 0);
			TL.innerHTML = formatDuration(  Math.round( mediaPlayer.getCurrentTime() , 0) );
		}
		
		mediaPlayer.on('audioprocess',timeUpdate);
		
		
		function waveMouseDown(evt){

			if (mediaRecord==null) return;
			var duration = mediaRecord.getData('length');
			if (isNaN(mediaPlayer.getDuration())==false)
			{
				// but use the mediaplayer duration if available,
				// since it is more accurate
				duration = mediaPlayer.getDuration();
			}
			var reg = YAHOO.util.Dom.getRegion( document.getElementById('waveform') );
			var relx = evt.pageX - reg.left;
			var prc = 100 * (evt.pageX - reg.left) / (reg.right - reg.left - 2) ;
			var thetime = (duration * prc / 100.0).toFixed(2);
			if (evt.button!=0) {
				// only left mouse click
				// but register position
				rightClickTime = thetime;
				return; 
			}
			if (isNaN(mediaPlayer.getDuration())) return;
			mediaPlayer.currentTime = thetime;		
		}
			
		document.getElementById('guiplayer1_progresspart').addEventListener('mousedown',waveMouseDown);		
		
		player_ct_menu = new YAHOO.widget.ContextMenu('player_ct_menu',
		{
			trigger: document.getElementById('guiplayer1_progresspart'),
			itemdata: [
					{ text: "<%~Web.AddAnnotation%>", onclick: {fn:AddMarker,obj:'add'} ,disabled: true},
					{ text: "<%~Web.DownloadRegion%>", onclick: {fn:ExtractRegion},disabled: true},
				],
			lazyload: true,
			zIndex: 10
		});
		
		
		player_ct_menu.hideEvent.subscribe(function()
		{
			rightClickTime = null;
		});	
		
		
		function onShow(p_sType, p_aArgs){
			var PM_DOWNLOAD = 2;
			
			var pm;
			var flags;
			var arch;
			
			if(typeof myDataTable !== 'undefined'){
				var row = myDataTable.getSelectedRows()[0];
				var record = myDataTable.getRecord( row );
					//if (record==null) return;
				pm = record.getData('pm');
				flags = record.getData('flags');
				arch = record.getData('arch')
					|| ( (flags&4)!=0 && LoadDelBackup);
				dwn = (pm & PM_DOWNLOAD) && arch;
			}else{
				pm = calldata['pm'];
				flags = calldata['flags'];
				arch = calldata['arch']
				dwn = (pm & PM_DOWNLOAD) && arch;
			}		
			
			if(waveSurferReady){
				player_ct_menu.getItem(0).cfg.setProperty('disabled', false );				
			}else{
				player_ct_menu.getItem(0).cfg.setProperty('disabled', true );
			}
			
			if((RegionEnd-RegionStart)>0&&dwn){
				player_ct_menu.getItem(1).cfg.setProperty('disabled', false );
			}else{
				player_ct_menu.getItem(1).cfg.setProperty('disabled', true );
			}		
		};
		
		player_ct_menu.subscribe("show", onShow);				
	}
	
	// Convert a audio-buffer segment to a Blob using WAVE representation
	function bufferToWave(abuffer, offset, len) {

		var numOfChan = abuffer.numberOfChannels,
		length = len * numOfChan * 2 + 44,
		buffer = new ArrayBuffer(length),
		view = new DataView(buffer),
		channels = [], i, sample,
		pos = 0;

		// write WAVE header
		setUint32(0x46464952);                         // "RIFF"
		setUint32(length - 8);                         // file length - 8
		setUint32(0x45564157);                         // "WAVE"

		setUint32(0x20746d66);                         // "fmt " chunk
		setUint32(16);                                 // length = 16
		setUint16(1);                                  // PCM (uncompressed)
		setUint16(numOfChan);
		setUint32(abuffer.sampleRate);
		setUint32(abuffer.sampleRate * 2 * numOfChan); // avg. bytes/sec
		setUint16(numOfChan * 2);                      // block-align
		setUint16(16);                                 // 16-bit (hardcoded in this demo)

		setUint32(0x61746164);                         // "data" - chunk
		setUint32(length - pos - 4);                   // chunk length

		// write interleaved data
		for(i = 0; i < abuffer.numberOfChannels; i++)
		channels.push(abuffer.getChannelData(i));

		while(pos < length) {
			for(i = 0; i < numOfChan; i++) {             							// interleave channels
				sample = Math.max(-1, Math.min(1, channels[i][offset])); 			// clamp
				sample = (0.5 + sample < 0 ? sample * 32768 : sample * 32767)|0; 	// scale to 16-bit signed int
				view.setInt16(pos, sample, true);          							// update data chunk
				pos += 2;
			}
			offset++                                   // next source sample
		}

		// create Blob
		return new Blob([buffer], {type: "audio/wav"});

		function setUint16(data) {
			view.setUint16(pos, data, true);
			pos += 2;
		}

		function setUint32(data) {
			view.setUint32(pos, data, true);
			pos += 4;
		}
	}

	function createBuffer(originalBuffer, duration) {
	  var sampleRate = originalBuffer.sampleRate
	  var frameCount = duration * sampleRate
	  var channels = originalBuffer.numberOfChannels 
	  return new AudioContext().createBuffer(channels, frameCount, sampleRate)
	}

	function copyBuffer(fromBuffer, fromStart, fromEnd, toBuffer, toStart) {
	  var sampleRate = fromBuffer.sampleRate
	  var frameCount = (fromEnd - fromStart) * sampleRate
	  for (var i = 0; i < fromBuffer.numberOfChannels; i++) {
		  var fromChanData = fromBuffer.getChannelData(i)
		  var toChanData = toBuffer.getChannelData(i)
		  for (var j = 0, f = Math.round(fromStart*sampleRate), t = Math.round(toStart*sampleRate); j < frameCount; j++, f++, t++) {
			  toChanData[t] = fromChanData[f]
		  }
	  }
	}
	
	function ExtractRegion(task){
		if((RegionEnd-RegionStart)>0){
			var saveData = (function () {
				var a = document.createElement("a");
				document.body.appendChild(a);
				a.style = "display: none";
				return function (data, fileName) {
					var	blob = new Blob([data], {type: "audio/wav"}),
						url = window.URL.createObjectURL(blob);
					a.href = url;
					a.download = fileName;
					a.click();
					if(window.navigator.userAgent.indexOf("Edge") > -1){
						window.navigator.msSaveBlob(url, fileName);
					}else{
						window.URL.revokeObjectURL(url);
					}					
				};
			}());
			var start = RegionStart;
			var end = RegionEnd;

			var duration = Math.round((end - start));

			var originalAudioBuffer;
			originalAudioBuffer = mediaPlayer.backend.buffer;

			// create a new buffer to hold the new clip
			var buffer = createBuffer(mediaPlayer.backend.buffer, duration)
			
			// copy
			copyBuffer(mediaPlayer.backend.buffer, start, end, buffer, 0)

			// load the new buffer
			var wav = bufferToWave(buffer,0,duration*originalAudioBuffer.sampleRate);

			saveData(wav,'recording-'+curID+'-' + Math.round(start) + '-'+Math.round(end)+'.wav');
		}else{
			alert("<%~Web.SelectRegion%>");//Please select a region.
		}
	}
	
	// event handler when context menu of a marker is chosen
	function MarkerAct(a,evt,action)
	{
		// which marker was it?
		// this is the menu item
		// this.parent is the ContextMenu
		// marker is the DIV that contains the marker
		var marker = this.parent.contextEventTarget;
		var obj_id = parseInt( marker.getAttribute('obj_id') );
		var markers = mediaRecord.getData('markers');
		var mark = markers[obj_id];
		if (action=='edit')
		{
			EnsureDialogAnnotationEdit();
			Dom.get('annotation_time').value = mark.timepos;
			Dom.get('annotation_notes').value = mark.descr;
			markerEditId = obj_id;
			dialog_annotation_edit.show();
			return;
		} else if (action=='del')
		{
			if (confirm("<%~Main.Delete?%>"))
			{
				DeleteMarker(obj_id);
			}
		} else if (action=='play')
		{
			MarkerPlay( mark );
		}
	}
	
	function MarkerPlay( mark )
	{
			if (audio5)
			{
				if (isNaN(mediaPlayer.duration)==true)
				{
					mediaSeekTime = mark.timepos;
					doPlay();
					return;
				}
				mediaPlayer.currentTime = mark.timepos;
				mediaPlayer.play();
			}
			if(wavesurfer){				
				if(waveSurferReady){
					mediaPlayer.seekTo(parseInt(mark.timepos)/mediaPlayer.getDuration());
				}else{
					mediaSeekTime = mark.timepos;
					playOnReady=false;
					doPlay();
				}				
			}
			if (embedPlayer)
			{
				if (mediaPlayer.Enabled && mediaPlayer.Duration)
				{
					mediaPlayer.currentPosition = parseFloat( mark.timepos );
					mediaPlayer.play();
				} else
				{
					mediaSeekTime = parseFloat( mark.timepos );
					doPlay();
				}
			}
	}
	
	function DeleteMarker(obj_id)
	{
		// delete remotely
		var callbackInfo = 
		{ success : function(o)
			{
				var ret = YAHOO.lang.JSON.parse(o.responseText);
				if (ret.errcode==0)
				{
					// delete in local array
					var markers = mediaRecord.getData('markers');
					delete markers[obj_id];
					// recreate markers (is easier)
					ShowMarkers();
				} else
				{
					alert('Failed to delete annotation. Error code: '+ret.errcode);
				}
			}
		, failure : function()
			{
				alert('Failed to contact server.');
			}
		};
		YAHOO.util.Connect.asyncRequest
		( 'POST'
		, document.URL
		, callbackInfo
		, 'act=del-marker-async'
			+ '&id=' + obj_id
      + '&SessionToken=' + encodeURIComponent(SessionToken)
		);
	}
	
	function GetMediaPlayerTimePos()
	{
		if (audio5)
		{
			return (mediaPlayer.currentTime).toFixed(2);
		}
		if (embedPlayer)
		{
			if (mediaPlayer.Enabled==false) return 0;

			return (mediaPlayer.currentPosition).toFixed(2);
		}
		if(wavesurfer){
			return (mediaPlayer.getCurrentTime()).toFixed(2);
		}
		return 0;
	}
	
	function AddMarker(task)
	{
		EnsureDialogAnnotationEdit();
		var timepos = GetMediaPlayerTimePos();
		if (rightClickTime!=null)
		{
			timepos = rightClickTime;
		}
		Dom.get('annotation_time').value = timepos;
		Dom.get('annotation_notes').value = '';
		markerEditId = -1; // means ADD
		dialog_annotation_edit.show();
		Dom.get('annotation_notes').focus();
	}
	
	function AnnotationAdd()
	{
		var marker_info = {};
		marker_info.call_id = mediaRecord.getData('id');
		marker_info.timepos = parseFloat(Dom.get('annotation_time' ).value);
		marker_info.descr   = Dom.get('annotation_notes').value;
		
		if (isNaN(marker_info.timepos) || marker_info.timepos>getMediaDuration())
		{
			alert('The specified time point is invalid');
			return false;
		}
		
		// add remotely
		var callbackInfo = 
		{ success : function(o)
			{
				var ret = YAHOO.lang.JSON.parse(o.responseText);
				if (ret.errcode==0)
				{
					// also add to the record,
					// for when we would switch between records,
					// without reloading
					var markers = mediaRecord.getData('markers');
					/*
					// next block no longer needed:
					if (markers==null)
					{
						mediaRecord.setData('markers',{});
						markers = mediaRecord.getData('markers');
					}
					*/
					markers[ ret.id ] = 
					{ 'label'  : ret.label
					, 'timepos': marker_info.timepos
					, 'descr'  : marker_info.descr
					, 'createdby'  : -1
					};
					// recreate markers
					// easier than only add new
					ShowMarkers();
				} else
				{
					alert('Failed to create annotation. Error code: '+ret.errcode);
				}
			}
		, failure : function()
			{
				alert('Failed to contact server.');
			}
		, argument: marker_info
		};
		YAHOO.util.Connect.asyncRequest
		( 'POST'
		, document.URL
		, callbackInfo
		, 'act=add-marker-async'
			+ '&call_id=' + marker_info.call_id
			+ '&timepos=' + marker_info.timepos
			+ '&descr=' + encodeURIComponent(marker_info.descr)
      + '&SessionToken=' + encodeURIComponent(SessionToken)
		);
		return true;
	}
	
	function StopAudio()
	{
		if (embedPlayer)
		{
			try{
			mediaPlayer.Stop();
			mediaPlayer.Enabled = false;
			mediaPlayingId = null;
			} catch(e)
			{
				alert(e);
			}
		}
		if (audio5)
		{
			mediaPlayer.pause();
			// there is warning here produced here about invalid URI
			// in the firebug console
			mediaPlayer.src = '';
			mediaPlayingId = null;
		}
		if(wavesurfer){
			mediaPlayer.pause();
		}
	}
	
	function ClearMarkers()
	{
    // console.log("ClearMarkers");
		if (!audio5 && !embedPlayer && !wavesurfer) return;
		for (ix in markerContainers)
		{
			markerContainers[ix].parentNode.removeChild( markerContainers[ix] );
		}
		markerContainers = [];
		markerList = [];
    markersShown = {};
	}

	function getMediaDuration()
	{
		// get the duration
		// use the database duration as default
		var duration=0;
		if(mediaRecord!=null){
			duration = mediaRecord.getData('length');
		}
		
		if (audio5)
		{
			if (isNaN(mediaPlayer.duration)==false)
			{
				// but use the mediaplayer duration if available,
				// since it is more accurate
				duration = mediaPlayer.duration;
			}
		}
		if (embedPlayer)
		{
			if (mediaPlayer.Enabled && mediaPlayer.Duration)
			{
				duration = mediaPlayer.Duration;
			}
		}
		if(wavesurfer){
			if(waveSurferReady){
				duration=mediaPlayer.getDuration();
			}
			
		}
		return duration;
	}
	
	// Create a marker with label (one character!)
	// at a number seconds
	// with a description (popup)
	function createMarker(id, label, seconds, descr, createdby,aRecord)
	{
		var duration = getMediaDuration();
		if (duration==0) return;
		
		var parentContainer = null;
		var measureItem = null;
		var markerContainerTop = "";
		var marginContainer = 0;
		if(wavesurfer){
			parentContainer = document.getElementById('waveform');
			measureItem = document.getElementById('waveform');
			markerContainerTop = "-2.5em";
		}else if (audio5){
			parentContainer = document.getElementById('guiplayer1_progresspart');
			measureItem = document.getElementById('guiplayer1_progressbar');
			markerContainerTop = "-2em";
		} else if (embedPlayer)
		{
			parentContainer = Dom.get('thePlayerContainer');
			measureItem = Dom.get('thePlayerContainer');
			markerContainerTop = "-2em";
			marginContainer = WMP_pb_margin;
		} else return;
		
    // determine class
    var classList = 'marker_container';
    if (typeof(searchobj)!='undefined' && typeof(searchobj.ann)!='undefined')
    {
      // match case insensitive
      var descrLwr = descr.toLowerCase();
      var annLwr = searchobj.ann.toLowerCase();
      var parts = annLwr.split(',');
      var matchNr = -1;
      var partNr = -1;
      for (ix in parts)
      {
        partNr ++;
        var part = parts[ix];
        if (descrLwr.indexOf(part)!=-1)
        {
          matchNr = partNr;
        }
      }
			
      if (matchNr!=-1)
      {
        var colorIx = (matchNr % 3) + 1;
        classList += ' marker_match' + colorIx;
      } else
      {
        classList += ' marker_nomatch';
      }
    }
    
		var marker_container = document.createElement('div');
		marker_container.setAttribute('class', classList );
		parentContainer.appendChild( marker_container );
		markerContainers.push( marker_container );
		
		var marker = document.createElement('div');
		marker.innerHTML = HtmlQuote( label );
		
		if(createdby==null){
			marker.setAttribute('class', 'markeritem_auto');
		}else{
			marker.setAttribute('class', 'markeritem');
		}
		
		
		marker_container.appendChild( marker );
		
		Event.on(marker,'click',function()
		{
			var markers = mediaRecord.getData('markers');
			var mark = markers[id];
			MarkerPlay( mark );
		});

    // note: the stick is only visible in classic layout
		var stick = document.createElement('div');
		stick.setAttribute('class', 'stick');
		marker_container.appendChild( stick );
		
		// get the region on the page occupied by the marker
		var m_reg = Dom.getRegion( marker );
		// get the width/height of the marker
		var m_width  = (m_reg.right-m_reg.left);
		var m_height = (m_reg.bottom-m_reg.top);
		// view progress bar
		var pb = measureItem;
		var pb_reg = Dom.getRegion( pb );

		// convert number of seconds to a fraction of the total duration
		var frc = seconds / duration;
		// convert the fraction to a position in pixels
		var pos = marginContainer + frc * (pb_reg.right - pb_reg.left - marginContainer*2);
		// let the middle of the marker be in this position
		// so adjust for the size of the marker
		var final_pos = Math.round( pos - m_width/2  );
		
		// place a little above the player progress bar
		marker_container.style.top = markerContainerTop;

		marker_container.style.left = final_pos + "px";
		setMarkerDescription(marker, seconds, descr);
		marker.setAttribute('obj_id', id);
		
		stick.style.left = (Math.round( m_width/2  )-2) + "px";
		stick.style.top = -1 + "px";
		
		markerList.push( marker );
		OnMarkerListChange();
	}

	function setMarkerDescription( marker, seconds, descr )
	{
		// set popup description
		marker.title = HtmlQuote(descr) + " ("+Math.round(seconds)+" <%~DateTime.s%>)";
	}
	
	function OnMarkerListChange()
	{
		if (marker_ct_menu==null)
		{
			marker_ct_menu = new YAHOO.widget.ContextMenu('marker_ct_menu',
			{
				trigger: markerList,
				itemdata: 
					[	{ text: "<%~Web.Play%>", onclick: {fn:MarkerAct,obj:'play'} }
					,	{ text: "<%~Main.Edit%>", onclick: {fn:MarkerAct,obj:'edit'} }
					,	{ text: "<%~Main.Delete%>", onclick: {fn:MarkerAct,obj:'del'} },
					],
				lazyload: true,
				zIndex: 10
			});
			marker_ct_menu.showEvent.subscribe(function()
			{
				marker_tooltip.hide();
			});
		}
		marker_ct_menu.cfg.setProperty('trigger',markerList);
		if (marker_tooltip==null)
		{
			marker_tooltip = new YAHOO.widget.Tooltip('marker_tooltip',
			{
				context : null, // to add later
				zIndex: 11
			});
		}
		marker_tooltip.cfg.setProperty('context',markerList);
	}
	
  function checkEqual(a,b)
  {
    return (JSON.stringify(a)==JSON.stringify(b));
  }
  
	function ShowMarkers()
	{
		if (!(audio5||wavesurfer) && !embedPlayer) return;

		if (mediaRecord==null)
    {
      // console.log("not media record - clear");
      ClearMarkers();
      return;
    }

		// get the markers of the selected record
		var markers = mediaRecord.getData('markers');
    
    if (checkEqual(markers,markersShown))
    {
      // console.log("equal markers so skip");
      return;
    }
    
    // console.log("notequal - clear");
		ClearMarkers();
		
		for (ix in markers)
		{
			var mark = markers[ix];
			createMarker( ix, mark.label, mark.timepos, mark.descr, mark.createdby, mediaRecord);
		}
    markersShown = JSON.parse(JSON.stringify(markers));
		// console.log("shown markers");
  }

	var prevFile="";
	var curID="";
	function GenPlay(id,filename,flags)
	{
		curID=id;
		// is the call encrypted? and key absent
		if ( (flags & 16)!=0 && AleKeyPresent==0 )
		{
			// the call is encrypted
			if (to_config || AlePlayUnlockUser)
			{
				// go to unlock page
				openurl('cryptunlock.php');
			} else
			{
				// no permission to unlock
				alert('<%~Crypt.PlayLocked%>');
				return;
			}
			return;
		}
		
		if (embedPlayer)
		{
      if(flags & 2048)
      {
        alert('<%~Web.CallEncryptPlayerUnsupported%>');
        return;
      }

			mediaPlayer.Enabled = true;
			mediaPlayer.FileName = 'getcall/' + filename + '?id=' + id + "&embed=1";
			return;
		}
		if (audio5){
      if(flags & 2048)
      {
        alert('<%~Web.CallEncryptPlayerUnsupported%>');
        return;
      }

			if(prevFile=='getcall/' + filename + '?id=' + id + "&embed=2"){
				if(mediaPlayer.paused==true){
					mediaPlayer.play();
				}else{
					mediaPlayer.pause();
				}								
			}else{
				mediaPlayer.src = 'getcall/' + filename + '?id=' + id + "&embed=2";
				mediaPlayer.load();
				mediaPlayer.play();						
			}
			prevFile='getcall/' + filename + '?id=' + id + "&embed=2";
			return;
		}
		if(wavesurfer){
			if(prevFile=='getcall/' + filename + '?id=' + id + "&embed=2"){
				if(mediaPlayer.isPlaying()){
					mediaPlayer.pause();
				}else{
					mediaPlayer.play();
				}
			}else{				
				setLoadingImg();
				mediaPlayer.unAll();				
				mediaPlayer.destroy();
				mediaPlayer.params.height=WaveHeight;
				
				InitWaveSurferPlayer();
				
				RegionStart=0;
				RegionEnd=0;
				mediaPlayer.disableDragSelection();
				mediaPlayer.clearRegions();
        
        if(flags & 2048)
        {
          if(call_encryption_available)
          {
            FetchWaveSurfer('getcall/' + filename + '?id=' + id + "&embed=2", id);
          }
          else
          {
            if(location.protocol != "https:")
            {
              alert("<%Web.CallEncryptNoPlay%> <%Web.CallEncryptHTTPSRequired%>");
            }
            else
            {
              alert("<%Web.CallEncryptNoPlay%> <%Web.CallEncryptBrowser%>");
            }
            
            return;
          }
        }
        else
        {
          mediaPlayer.load('getcall/' + filename + '?id=' + id + "&embed=2");
        }

				prevFile='getcall/' + filename + '?id=' + id + "&embed=2";
			}
			
			return;
		}
		openurl('getcall/' + filename + '?id=' + id);
  }
	