<?php

require_once('general.php');

HandlePage($dbintf);

function HandlePage($dbintf)
{
  global $rpl,$configs,$msg,$lng,$rooturl;

  if (($dbintf->actuinfo['permissions']&PM_CONFIG)==0)
  {
    echo 'Permission denied';
    exit;
  }

  $active_cnt = $dbintf->GetActiveCallsCount();

  //$configs = array_merge( $configs, $dbintf->LoadConfigsPart('o') );
  $step = 1;

  unset($_SESSION['LicMsg']);

	if (@file_exists('../apresa/conf/opt_so')==false)
	{
    $msg[] = new Msg(MSG_INF,'Page not applicable');
		// not for previous systems
    $_SESSION['msg'] = $msg;
    header('Location: '.$rooturl.'index.php');
		exit;
	}

	$LicSystem = (int) $dbintf->GetConfigValue('LicSystem');
	if ($LicSystem>0)
	{
    $msg[] = new Msg(MSG_INF,'The system license is already activated');
    $_SESSION['msg'] = $msg;
    header('Location: '.$rooturl.'index.php');
    exit;
	}

  $act = $_POST['act'];
  if ($act!='')
  {
  	if ($act=='genact')
  	{
			$lickey = $_POST['lickey'];
      LogAction('Software license activation input key');
      
      // allow reverting back to the old licensing method,
      // for compatibility with existing activation after reinstallation
      $licmethod = $_POST['licmethod'];
      if ($licmethod=='2' || $licmethod=='3')
      {
        $dbintf->SetConfigsPart( array('LicVersion'=>$licmethod) , 's' );
      }

			if (msg_signal_service($msg,'xlicreq '.$lickey))
      {
				$step = 2;
      } else {
        $msg[] = new Msg(MSG_ERR,'Failed to generate activation code');
      }

		}

		if ($act=='activate')
		{
      LogAction('Software license activate');
			$step = 2;
			if (isset($_POST['company']))
			{
				$company = $_POST['company'];
				$newconfigs = array();
				$newconfigs['CompanyNameSet'] = $company;
      	$dbintf->SetConfigsPart($newconfigs,'s');
			}
			// the reply from Vidicode activation server
			$acode = $_POST['acode'];

			// data is still in lc.dat
      if (msg_signal_service($msg,'xlicnew '.$acode))
      {
				// check if currently licensed and say so
			  $LicSystem = (int) $dbintf->GetConfigValue('LicSystem');
			  $LicDemo = (int) $dbintf->GetConfigValue('LicTrial');
			  if ($LicSystem>0 || $LicDemo>0)
			  {
        	$msg[] = new Msg(MSG_INF,'The system license is now activated');
					$step = 3;
					if ($dbintf->actuinfo['permissions']&PM_CONFIG)
					{
						UpdateSystemInfoCfg();
					}
				} else
				{
        	$msg[] = new Msg(MSG_ERR,'System licensing failed');
				}
			} else
			{
        $msg[] = new Msg(MSG_ERR,'Error: '.$reply);
			}
			OneTimeCheck();
		}

		if ($step==3)
		{
      // redirect
      $_SESSION['msg'] = $msg;
      header('Location: '.$rooturl.'systemopt.php');
			exit;
		}
  }

  $data = "var active_cnt = $active_cnt; \r\n";

  msg_signal_service($msg,'xlicver');
  
  $DefLicVersion = 3;
  // must get fresh value after xlicver
  $LicVersion = (int) $dbintf->GetConfigValue('LicVersion');
  if ($LicVersion != 0)
  {
    $DefLicVersion = $LicVersion;
  }
  
  // ready with database
  $dbintf->close();

	if ($step==1)
  {
    $data .= 'var DefLicVersion = ' . (int) $DefLicVersion . ';';
  }
	if ($step==2)
	{
		$lcdat = file_get_contents( DATA_PATH . '/lc.dat' );
		$data .= 'var lcdat = "' . JSQuote($lcdat) . '";';
	}

  $data .= GeneralJSData();

	if ($step==1)
	{
  	$template_content = file_get_contents('../apresa/templ/activation.htm');
  } else if ($step==2)
  {
  	$template_content = file_get_contents('../apresa/templ/activation2.htm');
  }

  // template replacements:
  $rpl['msg'] = message($msg);
  $rpl['nav'] = '';
  $rpl['MAINFORM'] = '<form id="mainform" method="POST"></form>';
  $rpl['FOOTER'] = '';
  $rpl['data'] = $data;
  $rpl['JSGEN'] = file_get_contents('../apresa/templ/general.js');
  $rpl['header'] = GetHeader();
  $template_content = do_replace_tags($template_content);
  echo $template_content;
}


?>
