<?php

require_once('general.php');
require_once 'smbgen.php';

HandlePage($dbintf);

function HandlePage($dbintf)
{
  global $rpl,$configs,$msg,$lng,$rooturl;

  if (($dbintf->actuinfo['permissions']&PM_CONFIG)==0)
  {
    echo 'Permission denied';
    exit;
  }

  $configs = array_merge( $configs, $dbintf->LoadConfigsPart('b') );
  $UseCallsArchive = (int) $dbintf->GetConfigValue('UseCallsArchive');

  $act = $_POST['act'];
  if ($act!='')
  {
    if ($act=='import' && $UseCallsArchive!=0)
    {
      $cfgnew = array();
      $cfgnew['BckCaImport'] = $_POST['BckFile'];
      $cfgnew['BckCaImporting'] = '1';
      $cfgnew['BckCaImportProgress'] = '...';
      $dbintf->SetConfigsPart($cfgnew,'b');
      msg_signal_service($msg,'CaImport');
      sleep(1);
    }

    // redirect
    $_SESSION['msg'] = $msg;
    header('Location: '.$rooturl.'backup-info.php');
    exit;
  }
  
  if ($UseCallsArchive==0)
  {
    $msg[] = new Msg(MSG_WRN,'This feature is switched off (System settings).');
  }

  $CallArchiveCnt = $dbintf->GetCallArchiveCount();
  
  if ( int_ensure_defined($configs['BckCaImporting']) == 1)
  {
    header('Refresh: 10; url='.$rooturl.'backup-info.php');
  }
  
  LogAction('View backup settings',array('level'=>'view'));

  // ready with database
  $dbintf->close();

  $data = GeneralJSData();

  $data .= 'var UseCallsArchive     = ' . (int) $UseCallsArchive . ";\r\n";
  $data .= 'var CallArchiveCnt      = ' . (int) $CallArchiveCnt . ";\r\n";
  $data .= 'var BckCaImporting      = ' . int_ensure_defined($configs['BckCaImporting']) . ";\r\n";
  $data .= 'var BckCaImportProgress = "' . JSQuote(str_ensure_defined($configs['BckCaImportProgress'])) . '"' . ";\r\n";
  
  $template_content = file_get_contents('../apresa/templ/backup-info.htm');
  
  // template replacements:
  $rpl['msg'] = message($msg);
  $rpl['nav'] = '';
  $rpl['MAINFORM'] = '<form id="mainform" method="POST"></form>';
  $rpl['FOOTER'] = '';
  $rpl['data'] = $data;
  $rpl['JSGEN'] = file_get_contents('../apresa/templ/general.js');
  $rpl['header'] = GetHeader();
  $template_content = do_replace_tags($template_content);
  echo $template_content;
}



?>
