<?php

require_once('general.php');

HandleContacts($dbintf);

function HandleContacts($dbintf)
{
  if (($dbintf->actuinfo['permissions']&(PM_VIEWPHONEBOOK|PM_T2_ADMIN))==0)
  {
    echo 'Permission denied';
    exit;
  }

  global $rpl,$msg, $lng;

  $search = '';
  if (isset($_GET['search']))
  {
    $search = $_GET['search'];
  }
  if (isset($_POST['search']))
  {
    $search = $_POST['search'];
  }
  $page = 1;
  if (isset($_GET['page']))
  {
    $page = (int) $_GET['page'];
  }
  if (isset($_POST['page']))
  {
    $page = (int) $_POST['page'];
  }

  $act = $_POST['act'];
  if ($act!='')
  {
    if ($act=='add-cid')
    {
      if ($dbintf->UseTenantContactList())
      {
        $cid = (int) $_POST['id'];
        $name = $_POST['name'];

        $cinfo = $dbintf->GetCallerIDonCallerID( $cid , false );
        if ($cinfo===false)
        {
          // unknown yet in the system
          $cinfo = $dbintf->GetOrCreateCallerID($cid,'',2);
        }
        LogAction("Add tenant contact",array('name'=>$name));
        if ($dbintf->AddTenantContact($cinfo['contactid'],$name)==false)
        {
          $msg[] = new Msg(MSG_ERR,GetErrDescr($dbintf->lasterr));
        }
      } else
      {
        $id = $_POST['id'];
        $ip = $_POST['ip'];
        $local = (int) $_POST['local'];
        $name = $_POST['name'];
        
        LogAction("Add contact",array('callerid'=>$id,'ip'=>$ip,'local'=>$local,'name'=>$name));
        
        $result = $dbintf->CreateCallerID($id,$ip,$local,$name);
        if ($result===false)
        {
          $msg[] = new Msg(MSG_ERR,GetErrDescr($dbintf->lasterr));
        }
      }
		}
		if ($act=='del-cid')
    {
      if ($dbintf->UseTenantContactList())
      {
        echo 'Action is not available for tenant contact list';
        exit;
      }
      $cids = explode(',',$_POST['del-cids']);
      $ctids = explode(',',$_POST['del-ctids']);
			
      foreach ($ctids as $ctid)
      {
        $ctinfo = $dbintf->GetContactInfo($ctid);
        LogAction("Delete contact",array('name'=>$ctinfo['name']));
      }
			
      if ($dbintf->DelContact($ctids,$cids,1)==false)
      {
        $msg[] = new Msg(MSG_ERR,GetErrDescr($dbintf->lasterr));
			}
		}
		if ($act=='edit-cid')
		{
      if ($dbintf->UseTenantContactList())
      {
        echo 'Action is not available for tenant contact list';
        exit;
      }
			$cid   = $_POST['cid'];
			$ctid  = $_POST['ctid'];
			$local = ($_POST['local']==1)?1:0;
			$name  = $_POST['name'];
			
      $cinfo = $dbintf->GetCallerID( (int) $cid );
			LogAction("Edited contact",array('callerid'=>$cinfo['callerid'],'local'=>$local,'name'=>$name));
			if ($dbintf->EditContact2($ctid,$cid,$local,$name)==false)
			{
        $msg[] = new Msg(MSG_ERR,GetErrDescr($dbintf->lasterr));
			}
		}
    if ($act=='edit-ct')
    {
			LogAction("Edited contact",array('name'=>$_POST['edit-name']));
      if ($dbintf->EditContact($_POST['edit-id'],$_POST['edit-name'])==false)
      {
        $msg[] = new Msg(MSG_ERR,GetErrDescr($dbintf->lasterr));
      }
    }
    // redirect
    $_SESSION['msg'] = $msg;
    header('Location: contacts.php?page='.$page.'&search='.urlencode($search));
  }
	
  $useTenantContactList = $dbintf->UseTenantContactList();
  if ($useTenantContactList)
  {
    LogAction("View Tenant Contacts",array('level'=>'view'));
    $CtType = $lng->Get('Web.Tenant');
  } else
  {
    LogAction("View Contacts",array('level'=>'view'));
    $CtType = $lng->Get('System.System');
  }
	
  // too large to load: $dbintf->GetCallerIDList();
  // so now async.
  
  // ready with database
  $dbintf->close();

  $data = 'var pm_edit_names = '. (($dbintf->actuinfo['permissions']&PM_EDITNAMES)?1:0) . ";\r\n";
  $data .= GeneralJSData();
  $data .= 'var pagenr = ' . $page  . ";\r\n";
  $data .= 'var initsearch = "' . JSQuote($search) . "\";\r\n";
  $data .= 'var tenantContactList = ' . ($useTenantContactList?1:0) . ";\r\n";

  $template_content = file_get_contents('../apresa/templ/contacts.htm');

  // template replacements:
  $rpl['msg'] = message($msg);
  $rpl['nav'] = '';
  $rpl['MAINFORM'] = '<form id="mainform" method="POST"></form>';
  $rpl['FOOTER'] = '';
  $rpl['data'] = $data;
  $rpl['CtType'] = $CtType;
  $rpl['JSGEN'] = file_get_contents('../apresa/templ/general.js');
  $rpl['header'] = GetHeader();
  $template_content = do_replace_tags($template_content);
  echo $template_content;
}



?>
