<?php

require_once('general.php');

HandlePage($dbintf);


function HandlePage($dbintf)
{
  global $rpl,$configs,$msg,$lng,$rooturl;

  if (($dbintf->actuinfo['permissions']&PM_CONFIG)==0)
  {
    echo 'Permission denied';
    exit;
  }

  $act = $_POST['act'];
  if ($act!='')
  {

    // redirect
    $_SESSION['msg'] = $msg;
    header('Location: '.$rooturl.'network.php');
    exit;
  }
  
  LogAction("View Network status.",array('level'=>'view'));

  $con = '';
  $listen = '';
  $ufw_status = '';
  if (msg_signal_service($msg,'network status')==false)
  {
    // problem
  } else
  {
    $ufw_status = @file_get_contents('/var/apresa/data/ufw_status.dat');
    if ($ufw_status===false) $ufw_status = 'Not installed';
    
    $con_lines = @file('/var/apresa/data/network_con.dat');
    if ($con_lines !== false)
    {
      $firstline = true;
      foreach ($con_lines as $line)
      {
        if ($firstline)
        {
          $firstline = false;
          continue;
        }
        $parts = preg_split('/\s+/',$line);
        // skip localhost
        if (count($parts)>4
        && (  startsWith($parts[3],'127.0.0.1:')  // IPv4
           || startsWith($parts[3],'::1:')        // IPv6
        ) )
        {
          continue; 
        }
        $con .= $line;
      }
    }
    
    $listen_lines = @file('/var/apresa/data/network_listen.dat');
    if ($listen_lines !== false)
    {
      $firstline = true;
      foreach ($listen_lines as $line)
      {
        if ($firstline)
        {
          $firstline = false;
          continue;
        }
        $parts = preg_split('/\s+/',$line);
        // skip localhost
        if (count($parts)>4
        && (  startsWith($parts[3],'127.0.0.1:')  // IPv4
           || startsWith($parts[3],'::1:')        // IPv6
        ) )
        {
          continue; 
        }
        $listen .= $line;
      }
    }
  }

  // ready with database
  $dbintf->close();

  $data = '';
  
  $data .= 'var network_con = ' . json_encode($con) . ';';
  $data .= 'var network_listen = ' . json_encode($listen) . ';';
  $data .= 'var ufw_status = ' . json_encode($ufw_status) . ';';

  $data .= GeneralJSData();

  $template_content = file_get_contents('../apresa/templ/network.htm');

  // template replacements:
  $rpl['msg'] = message($msg);
  $rpl['nav'] = '';
  $rpl['MAINFORM'] = '<form id="mainform" method="POST"></form>';
  $rpl['FOOTER'] = '';
  $rpl['data'] = $data;
  $rpl['filestab'] = $tab;
  $rpl['JSGEN'] = file_get_contents('../apresa/templ/general.js');
  $rpl['header'] = GetHeader();
  $template_content = do_replace_tags($template_content);
  echo $template_content;
}



?>
