<?php

require_once('general.php');
require_once 'listinggen.php';

HandlePage($dbintf);

function HandlePage($dbintf)
{
  global $rpl,$configs,$configs_s,$actuinfo,$msg,$lng,$rooturl;

  $handler = new ListingHandler();
  $handler->filterData = true;
  $handler->search_accepted[] = 'usrnm';
  $handler->viewAuditLogText = "View recycle bin of calls";

  $act = str_ensure_defined($_POST['act']);
  if ($act!='')
  {
		if ($act=='del-record')
		{
			if (isset($_POST['del-ids']))
			{
				$handler->delfromrb = true;
				$handler->ListingAct($act, $rooturl);
			}
			else
			{
				$msg[] = new Msg(MSG_WRN,'No records selected!');
			}
    }
    if($act=='mass-rec-record' || $act=='mass-del-record')
    {
      $handler->delfromrb = true;
      $handler->ListingAct($act, $rooturl);
    }
		if ($act=='rec-record')
		{
			if (isset($_POST['rec-ids']))		//Recover deleted calls!
			{
					$recording_ids = $_POST['rec-ids'];
					$recording_ids = explode(',',$recording_ids);
		      foreach ($recording_ids as $recording_id)
		      {
		        $info = $dbintf->GetCallInfo($recording_id);
		        if ($info===false)
		        {
		          $msg[] = new Msg(MSG_ERR,'Record not found');
		        } else if (($info['permissions']&PM_DELETE)==0)
		        {
		          $msg[] = new Msg(MSG_ERR,GetErrDescr('pm-denied'));
		        } else
		        {
								LogAction('Recover call from RecycleBin', array('call_id'=>$recording_id) );
								$dbintf->RecoverRecordingRB($recording_id);
						}
					}
			}
			else
			{
				$msg[] = new Msg(MSG_WRN,'No records selected!');
			}
		}
    // redirect to same URL (but without POST data)
    $_SESSION['msg'] = $msg;
    $newurl = $rooturl.$redirect_url . 'recyclecalls.php';
    header('Location: '.$newurl);
    exit;
  }

	$handler->ParseSearch();

	//Only the calls in the recycle bin!
	$handler->search_use['rb'] = 1;
	$handler->PerformSearch();
	
	// LogAction done in listinggen

	$options = array();
	$calldata = '';
	$calldata .= $handler->GetBasicJsData($options);

  $dbintf->close();
  $calldata .= GeneralJSData();

  $template_content = file_get_contents('../apresa/templ/recyclecalls.htm');
  // template replacements:
  $handler->SetDefReplacements();
  $rpl['data'] = $calldata;
  $template_content = do_replace_tags($template_content);
  echo $template_content;
}

?>