<?php

require_once('general.php');

HandlePage($dbintf);

function GetSerialNumber()
{
	return file_get_contents('../apresa/conf/serial');
}

function HandlePage($dbintf)
{
  global $rpl,$msg,$lng,$rooturl;

  if (($dbintf->actuinfo['permissions']&PM_CONFIG)==0)
  {
    echo 'Permission denied';
    exit;
  }

	$configs = array();

  $act = $_POST['act'];
  if ($act!='')
  {
    if ($act=='alarmtty' || $act=='compact' || $act=='powercom'
    || $act=='powerpar' || $act=='alarmusb' || $act=='optimizeDB' || $act=='revertOptimizeDB')
    {
      LogAction('Apresa special action',array('act'=>$act) );
      if (msg_signal_service($msg,'special '.$act,30))
      {
        $msg[] = new Msg(MSG_INF,'OK');
      }
		}

    // redirect
    $_SESSION['msg'] = $msg;
    header('Location: '.$rooturl.'specials.php');
    exit;
  }


	$configs = $dbintf->LoadConfigs();
	$serialnum = (int) GetSerialNumber();

	LogAction("View Apresa specials page",array('level'=>'view'));
	
  $data = '';
  $data .= 'var OptimizedDB = ' . int_ensure_defined($configs['OptimizedDb']) . ';';
  $data .= 'var serialnum = "' . $serialnum . '";';
  $data .= GeneralJSData();

  $template_content = file_get_contents('../apresa/templ/specials.htm');

  // template replacements:
  $rpl['msg'] = message($msg);
  $rpl['nav'] = '';
  $rpl['MAINFORM'] = '<form id="mainform" method="POST"></form>';
  $rpl['FOOTER'] = '';
  $rpl['data'] = $data;
  $rpl['healthinfo'] = $healthinfo;
  $rpl['JSGEN'] = file_get_contents('../apresa/templ/general.js');
  $rpl['header'] = GetHeader();
  $template_content = do_replace_tags($template_content);
  echo $template_content;
}



?>
