<?php

require_once('general.php');
require_once 'utility.php';
require_once 'callhandler.php';

HandleMain($dbintf);

function HandleMain($dbintf)
{
  global $rpl,$configs,$msg;

	$id = (int) $_GET['id'];
	
	LogAction("View transcription",array("level"=>"view","call_id"=>$id));
  
  $transcript = $dbintf->GetTranscript($id);
  if ($transcript === false)
  {
    echo GetErrDescr($dbintf->lasterr);
    exit;
  }
  
  $template_content = file_get_contents('../apresa/templ/viewtranscript.htm');

  $data = '';
	$data .= 'var transcript = "' . JSQuote($transcript) . '";' . "\r\n";
  $data .= GeneralJSData();
	
  // template replacements:
  $rpl['data'] = $data;
  $rpl['genlist_css'] = file_get_contents('../apresa/templ/genlist.css');
  $rpl['JSGEN'] = file_get_contents('../apresa/templ/general.js');
  $template_content = do_replace_tags($template_content);
  echo $template_content;
}



?>