<?php

require_once('general.php');

HandlePage($dbintf);

function HandlePage($dbintf)
{
  global $rpl,$configs,$msg,$lng,$rooturl;

  if (($dbintf->actuinfo['permissions']&PM_CONFIG)==0)
  {
    echo 'Permission denied';
    exit;
  }
	
  $act = $_POST['act'];
  if ($act!='')
  {
		if ($act=='addaudio')
		{
			LogAction("Upload notification message for VoIP service (telephony)");
			$ok = true;
			$thefile = $_FILES['thefile'];
			$rule = int_ensure_defined($_POST['rule']);
			if ($ok && $rule<=0)
			{
				$msg[] = new Msg(MSG_ERR,'Error (rule)');
				$ok = false;
			}

			if ($ok && isset($thefile)==false)
			{
				$msg[] = new Msg(MSG_ERR,'No file uploaded.');
				$ok = false;
			} 
			if ($ok && $thefile['error']!=0)
			{
				// error in upload
				$msg[] = new Msg(MSG_ERR,'Error in file upload. '.GetUploadErrDescr($thefile['error']));
				$ok = false;
			} 
			if ($ok)
			{
				// there is a good upload
				if (is_uploaded_file($thefile['tmp_name'])==false)
				{
					echo 'Not the uploaded file.';
					exit;
				}
				
				// find original extension
				// otherwise sox does not know what to do with it
				$pi = pathinfo($thefile['name']);
				$tmpfn = $thefile['tmp_name'] . '.' . $pi['extension'];
				if (move_uploaded_file($thefile['tmp_name'], $tmpfn)==false)
				{
					echo 'cannot move uploaded file';
					exit;
				}
				
				//$msg[] = new Msg(MSG_INF,'Good upload. '.$thefile['type']);
				if (msg_signal_service($msg,'voippbx addaudio '.$tmpfn.' '.$rule))
				{
					$msg[] = new Msg(MSG_INF,$lng->Get('Main.OK'));
				} else {
					$msg[] = new Msg(MSG_ERR,'The file could not be converted to the required format.');
					$ok = false;
				}
				
				unlink($tmpfn);
				
			}

      // redirect
      $_SESSION['msg'] = $msg;
			$target = $rooturl.'voippbx_upload.php?rule='.$rule;
			if ($ok) $target .= '&close=1';
      header('Location: '.$target);
      exit;
		}
  }
  
	if (!defined('DEMO') && COM_TYPE!='Win')
	{
		if (file_exists('/usr/bin/yate')==false)
		{
			$msg[] = new Msg(MSG_ERR,$lng->Get('This module is not installed'));
		}
	}
	
  $data = '';
	$data .= 'var toclose = '.((int_ensure_defined($_GET['close'])!=0)?'1':'0').';'."\r\n";
	$data .= 'var rule = '.int_ensure_defined($_GET['rule']).';'."\r\n";
	//echo '<PRE>'.$data;
	//exit;
  
  // ready with database
  $dbintf->close();

 
  $data .= GeneralJSData();

  $template_content = file_get_contents('../apresa/templ/voippbx_upload.htm');

  // template replacements:
  $rpl['msg'] = message($msg);
  $rpl['nav'] = '';
  $rpl['MAINFORM'] = '<form id="mainform" method="POST"></form>';
  $rpl['FOOTER'] = '';
  $rpl['data'] = $data;
  $rpl['JSGEN'] = file_get_contents('../apresa/templ/general.js');
  $rpl['header'] = GetHeader();
  $template_content = do_replace_tags($template_content);
  echo $template_content;  
}
