#!/bin/bash

echo "Run clusterupdate.sh"

function upgrade_cluster()
{
  crm configure show | grep drbd_and_fs
  if [ "$?" -eq "0" ]
  then
    echo "Upgrading cluster ..."
    crm cib new newconf
    
    crm -c newconf configure delete drbd_and_fs
    crm -c newconf configure delete drbd_then_fs
    
    crm -c newconf configure colocation drbd_and_grp  inf: apgrp              ms_drbd_r0:Master
    crm -c newconf configure order      drbd_then_grp inf: ms_drbd_r0:promote apgrp:start
    
    crm cib commit newconf
    crm cib delete newconf
    echo "End of cluster upgrade"
  else
    echo "Cluster upgrade not needed"
  fi
}

if [ -f /var/apresa/conf/opt_cluster ]
then
  upgrade_cluster
fi
