<?php

/* Accept incoming call,
   optionally play test tones
*/
class ActAcceptCall extends RuleHandlerBase
{
  var $main; // actually the ruler and not main
  
  function Init($defMain)
  {
    $this->main = $defMain;
  }
  
  function GetTarget()
  {
    $TT = $this->main->ruleCfg['TT'];
    if ($TT==0)
    {
      return 'simplyaccept/';
    } else if ($TT==1)
    {
      return 'tone/info';
    } else if ($TT==2)
    {
      return 'tone/silence';
    }
  }
  
  function RoutingCall($ev)
  {
    $ev->retval = $this->GetTarget();
    $ev->handled = true;
    return true;
  }
  
  function UnansweredCall()
  {
    $m = new Yate("call.answered");
    $m->params["id"] = $this->main->instanceId;
    $m->params["targetid"] = $this->main->originalData['id'];
    $m->Dispatch();
    
    $this->ActiveCall();
  }
  
  function ActiveCall()
  {
    dbglog("forward to " . $this->GetTarget() );
    $m = new Yate("chan.masquerade");
    $m->params['message'] = 'call.execute';
    $m->params['callto'] = $this->GetTarget();
    $m->params['id'] = $this->main->originalData['id'];
    $m->Dispatch();
  }
  
  
};


?>