#!/bin/sh

# reset database to factory default
# it means all recordings are deleted
# and configuration is reset
# except the license keys
sudo -u www-data psql apresa -f /var/apresa/data/delall.sql
sudo -u www-data psql apresa -f /var/apresa/data/default-accounts.sql
sudo -u www-data psql apresa -f /var/apresa/data/default-configs.sql

# remove files
rm -R /recordings/2*
rm -R /recordings/log
# but not /recordings/db !
# but recreate this
mkdir /recordings/log
chmod 777 /recordings/log

# remove
rm -R /dev/shm/apresa
# and recreate
/usr/share/apresa/apinit.sh

# remove other data
rm /var/apresa/data/*.dat
rm /var/apresa/data/*.ekey
rm /var/apresa/data/*.ini
rm /var/apresa/data/eth_drop
rm /var/apresa/data/health.htm

# remove log files
rm /var/log/apresa/*
rm /var/log/orkaudio/*

service rsyslog restart

