-- For PostgreSQL

-- Administrator account
INSERT INTO Accessors
( id, type )
VALUES
(  5,    0 );
INSERT INTO Users
( accid, usr, pwd, enabled, permissions, name, email, extra)
VALUES
( 5, 'admin', '21232f297a57a5a743894a0e4a801fc3', 1, 0, 'Administrator', '', '');
-- full permission
INSERT INTO AccAcc(accid,callaccid,epermissions,applytype)
VALUES(5,0,127,0);

-- Root group
INSERT INTO Accessors
( id, type )
VALUES
(  6,    1 );
INSERT INTO Groups
(accid, name          , permissions, extra, typegrp, super)
VALUES
(   6, 'Organization',           0,  NULL,       0,     0);

-- Allow users to list, play and takes notes for their own calls
INSERT INTO AccAcc(accid,callaccid,epermissions,applytype)
VALUES(6,-1,19,1);
-- No extra permissions for those in own group, but this can be changed
INSERT INTO AccAcc(accid,callaccid,epermissions,applytype)
VALUES(6,-2, 0,1);
-- Allows management full access to users in subgroups
INSERT INTO AccAcc(accid,callaccid,epermissions,applytype)
VALUES(6,-3,23,1);

-- Postgresql specifics
SELECT setval('accessors_id_seq',7);


-- Add-on specifics
INSERT INTO CEAnswerTypes(description,type)
	VALUES (E'Good=2\\Avg.=1\\Poor=0',1);
INSERT INTO CEAnswerTypes(description,type)
	VALUES (E'Yes=10\\No=0',1);
INSERT INTO CEAnswerTypes(description,type)
	VALUES (E'Yes=10\\Y/N=5\\No=0',1);
INSERT INTO CEAnswerTypes(description,type)
	VALUES (E'++=2\\+=1\\0=0\\-=-1\\--=-2',1);



