	// Searching include file
	
  var dialogfd, calfd;
  var dialogld, calld;
	var CatNiceBtn = null;
	var cattosearch = -1;

  var search_ids = [
      ['id','l1','r1','c1'],
      ['ip','l2','r2',''],
      ['nm','ln','rn','cn']
    ];
  var notes_fields = [];
  var notes_fields_count = 5;
  for (var i=1;i<=notes_fields_count;i++)
  {
    var fld = 'nts';
    if (i!=1) fld += i;
    notes_fields.push( fld );
  }
	var data_fields = [];
	var data_fields_count = 5;
	for(var i=1; i<=data_fields_count;i++)
	{
		var fld = 'dts' + i;
		data_fields.push(fld)
	}

  function ParseDate(dt)
  {
    dt = strtrim(dt);
    var ts = getDateFromFormat2(dt,datef);
    if (ts!=0) return ts;
    // also try default
    var ts = getDateFromFormat2(dt,'yyyy-MM-dd');
    return ts;
  }
	
  function ParseDateDay(dt)
  {
    dt = strtrim(dt);
    var ts = ParseDate(dt);
    if (ts==0) return '';
    ts.setSeconds(0);
    ts.setMinutes(0);
    ts.setHours(0);
    return ts.getTime()/1000;
  }

	function SetSearchCategory(val)
	{
    cattosearch = val;
    if (CatNiceBtn==null) return;
    if (val==-1)
    {
    	CatNiceBtn.set('label','&nbsp;');
    	return;
		}
    var cat = categoryList[val];
		var extrat = '';
		if (cat.value!=0)
		{
			extrat = '<span class="catbox cat'+cat.value+'"></span> ';
		}
    CatNiceBtn.set('label',extrat+cat.label);
	}
	
	function CatSearchClick(param1,param2,targetobj)
	{
		var tp = targetobj.id;
		SetSearchCategory(parseInt(tp.substr(9),10));
	}
	
  function resetSearch()
  {
    var searchform = document.getElementById("searchform");
    cnt = searchform.elements.length;
    // Clear every param
    for (i = 0 ; i < cnt ; ++i)
    {
      var elem = searchform.elements[i];
      if (elem.type=='select-one')
      {
        elem.selectedIndex = 0;
      } else
      {
        elem.value = '';
      }
    }
    SetSearchCategory(-1);
    SearchSubmit();
  }

  function OnCalBtnClick(mouseevent,param)
  {
           var btnid = param[0];
           var btnobj = param[1];
           var dialog = param[2];
           var calendar = param[3];
           var inpid = param[4];
           var caption = param[5];
            // Adapted from YUI example
            if (!dialog) {

                // Hide Calendar if we click anywhere in the document other than the calendar
                Event.on(document, "click", function(e) {
                    var el = Event.getTarget(e);
                    var dialogEl = dialog.element;
                    if (el != dialogEl && !Dom.isAncestor(dialogEl, el) && el != btnobj && !Dom.isAncestor(btnobj, el)) {
                        dialog.hide();
                    }
                });

                function PrevHandler() {
                  calendar.previousYear();
                }
                function NextHandler() {
                  calendar.nextYear();
                }

                dialog = new YAHOO.widget.Dialog("container", {
					modal: true,
                    visible:false,
                    context:[btnid, "tl", "bl"],
                    buttons:[ {text:"<%Web.CalPrevYear%>", handler: PrevHandler}
                    ,{text:"<%Web.CalNextYear%>", handler: NextHandler}],
                    draggable:false,
                    close:true
                });
                dialog.setHeader(caption);
                dialog.setBody('<div id="cal"></div>');
                dialog.render(document.body);

                dialog.showEvent.subscribe(function() {
                    if (YAHOO.env.ua.ie) {
                        // Since we're hiding the table using yui-overlay-hidden, we
                        // want to let the dialog know that the content size has changed, when
                        // shown
                        dialog.fireEvent("changeContent");
                    }
                });
            }

            // Lazy Calendar Creation - Wait to create the Calendar until the first time the button is clicked.
            if (!calendar) {

                calendar = new YAHOO.widget.Calendar("cal", {
                    navigator: true,
                    iframe:false          // Turn iframe off, since container has iframe support.
                });
                calendar.render();

                calendar.selectEvent.subscribe(function() {
                    if (calendar.getSelectedDates().length > 0)
                    {

                        var selDate = calendar.getSelectedDates()[0];
                        var formatedData = formatDate(selDate, datef);
                        Dom.get(inpid).value = formatDate(selDate,datef);
                    }
                    dialog.hide();
                });

                calendar.renderEvent.subscribe(function() {
                    // Tell Dialog it's contents have changed, which allows
                    // container to redraw the underlay (for IE6/Safari2)
                    dialog.fireEvent("changeContent");
                });
            }

            var inputtext = Dom.get(inpid).value;
            if (inputtext!='')
            {

              var ts = ParseDate(inputtext);
              if (ts!=0)
              {
                var month = ts.getMonth()+1;
                var year = ts.getFullYear();
                calendar.select(ts);
                calendar.cfg.setProperty("pagedate",month+"/"+year);
                calendar.render();
              }
            }

            dialog.show();
  }

	function QuickDateClick(param1,param2,targetobj)
	{
		var tp = targetobj.id;
		// what is it today
		var dt = new Date();
		dt.setHours(11); // for safety, somewhere in the middle of the day
		var mn = parseInt(tp.charAt(1),10);
		if (tp.charAt(0)=='y')
		{
			dt.setDate(1);
			dt.setMonth(0);
			dt.setYear( dt.getFullYear()-mn );
			Dom.get('FdInp').value = formatDate(dt,datef);
			dt.setYear( dt.getFullYear()+1 );
			// one day back
			dt.setTime( dt.getTime()-1000*60*60*24 );
			Dom.get('LdInp').value = formatDate(dt,datef);
		}
		if (tp.charAt(0)=='m')
		{
			dt.setDate(1);
			var month = dt.getMonth();
			var year = dt.getFullYear();
			month -= mn;
			if (month<0) {month+=12;year--;}
			dt.setMonth( month );
			dt.setFullYear( year );
			Dom.get('FdInp').value = formatDate(dt,datef);
			month ++;
			if (month>=12) { month-=12; year++; }
			dt.setMonth( month );
			dt.setFullYear( year );
			// one day back
			dt.setTime( dt.getTime()-1000*60*60*24 );
			Dom.get('LdInp').value = formatDate(dt,datef);
		}
		if (tp.charAt(0)=='w')
		{
			dt.setTime( dt.getTime()-1000*60*60*24*(dt.getDay()+7*mn) );
			Dom.get('FdInp').value = formatDate(dt,datef);
			dt.setTime( dt.getTime()+1000*60*60*24*6 );
			Dom.get('LdInp').value = formatDate(dt,datef);
		}
		if (tp.charAt(0)=='d')
		{
			dt.setTime( dt.getTime()-1000*60*60*24*mn );
			Dom.get('FdInp').value = formatDate(dt,datef);
			Dom.get('LdInp').value = formatDate(dt,datef);
		}

	}
	
  function addNE(key,value)
  {
    if (value!='')
    {
      addData(key,value);
    }
  }

	function InZ(num,len)
	{
	  num = '' + num;
    while (num.length<len)
    {
      num = '0' + num;
    }
    return num;
	}

  function GetTimeOfDayStr(minutes)
  {
    var h = Math.floor(minutes / 60);
    var m = minutes % 60;
    return InZ(h,2)+':'+InZ(m,2);
  }

  function ParseMinutesSeconds(text)
  {
    var colon_pos = text.indexOf(':');
    var minutes,seconds;
    if (colon_pos==-1){
      minutes = 0;
      seconds = parseInt(text,10);
    } else {
      minutes = parseInt(text.substr(0,colon_pos),10);
      seconds = parseInt(text.substr(colon_pos+1),10);
    }
		return minutes*60+seconds;
	}
	
  function ParseTimeOfDayToMinutes(text)
  {
    var colon_pos = text.indexOf(':');
    var hours,minutes;
    if (colon_pos==-1){
      hours = parseInt(text,10);
      minutes = 0;
    } else {
      hours = parseInt(text.substr(0,colon_pos),10);
      minutes = parseInt(text.substr(colon_pos+1),10);
    }
    if (isNaN(hours)) return -1;
    if (isNaN(minutes)) return -1;
    var value = hours*60+minutes;
    if (value>=24*60) return -1;
    return value;
  }

  function SearchPrepareGeneral()
  {
		// Date (From / Till)

    var Fd = ParseDateDay( Dom.get('FdInp').value );
    var Ld = ParseDateDay( Dom.get('LdInp').value );

    if ((Fd==0 && Dom.get('FdInp').value!='')
    || (Ld==0 && Dom.get('LdInp').value!='')
    ){
      alert('Invalid date');
      return false;
    }

    addNE('fd',Fd);
    addNE('ld',Ld);

		// Time of day (From / Till)

    if (Dom.get('FtInp').value!='')
    {
      var Ft = ParseTimeOfDayToMinutes( Dom.get('FtInp').value );
      if (Ft==-1)
      {
        alert('Invalid time');
        return false;
      }
      addData('ft',GetTimeOfDayStr(Ft));
    }

    if (Dom.get('LtInp').value!='')
    {
      var Lt = ParseTimeOfDayToMinutes( Dom.get('LtInp').value );
      if (Lt==-1)
      {
        alert('Invalid time');
        return false;
      }
      addData('lt',GetTimeOfDayStr(Lt));
    }

    // Duration (From / Till)

    var DurFrom = ParseMinutesSeconds(Dom.get('DurFrom').value);
    if (isNaN(DurFrom)==false)
    {
			addData('fdur',DurFrom);
		}
    var DurTo = ParseMinutesSeconds(Dom.get('DurTo').value);
    if (isNaN(DurTo)==false)
    {
			addData('ldur',DurTo);
		}

    for (ix in search_ids)
    {
      var prop = search_ids[ix];
      if (Dom.get(prop[0]).value!='')
      {
        var value = Dom.get(prop[0]).value;
        if (Dom.get('d'+prop[0])!=null)
        {
          addData( prop[ Dom.get('d'+prop[0]).selectedIndex ] , value );
        }
        if (Dom.get('e'+prop[0]).checked)
        {
          addData( 'e'+prop[0], '1' );
        }
      }
    }
    
    var anyNote = false;
    for (ix in notes_fields)
    {
      var fld = notes_fields[ix];
      var val = Dom.get(fld).value;
      if (val != '') anyNote = true;
      addNE(fld,val);
    }
    if (anyNote && Dom.get('ents').checked)
    {
      addData('ents','1');
    }
		
		var anyData = false;
		for(ix = 0; ix < data_fields.length; ++ix)
		{
			var fld = data_fields[ix];
			var val = Dom.get(fld).value;
			if (val != '') anyData = true;
			addNE(fld, val)
		}
		if(anyData && Dom.get('ents').checked)
		{
			addData('ents','1');
		}
    if (Dom.get('ann')!=null)
    {
      addNE('ann',Dom.get('ann').value);
    }
    if (Dom.get('tra')!=null)
    {
      addNE('tra',Dom.get('tra').value);
    }

    if (Dom.get('dir').selectedIndex>0)
    {
      addData('dir',Dom.get('dir').selectedIndex-1);
    }

    if (cattosearch!=-1)
    {
      addData('cat',cattosearch);
    }

		var linenr_list = Dom.get('lnr').value;
		if (linenr_list!='')
		{
			var items = linenr_list.split(',');
			var t = '';
			for (ix in items)
			{
				var iLineNr = parseInt(items[ix],10);
				if (!isNaN(iLineNr) && iLineNr>=0 && iLineNr<100000)
				{
					if (t!='') t += ','
					t += iLineNr;
				} else
				{
					alert('Invalid line number');
					return false;
				}
			}
			addNE('lnr',t);
  	}
  	
  	var usrnm = Dom.get('usrnm').value;
  	if (usrnm!='')
  	{
			addData('usrnm',usrnm);
		}

  	var agent = Dom.get('agent').value;
  	if (agent!='')
  	{
			addData('agent',agent);
		}
		
  	var tenant = Dom.get('tenant').value;
  	if (tenant!='')
  	{
			addData('tenant',tenant);
		}
    
  	var rem = Dom.get('rem').value;
  	if (rem!='')
  	{
			addData('rem',rem);
		}
    
    var recDom = Dom.get('rec');
    if (recDom!=null)
    {
      var rec = Dom.get('rec').value;
      if (rec!='')
      {
        addData('rec',rec);
      }
    }
    
    return true;
  }

  function search_hideClass(cls)
  {
  	var list = Dom.getElementsByClassName(cls,null,null);
    Dom.addClass(list,'invis');
  }
  function search_showClass(cls)
  {
  	var list = Dom.getElementsByClassName(cls,null,null);
    Dom.removeClass(list,'invis');
  }
  
  /* insideCallListing: search block shown in a page featuring a call listing, it includes,
      - buttons to search/reset,
      - showcols is used *more strictly* to filter what we can search on
      - a recorders array
      - a own/all calls switch
  */
  function InitSearchDisplay(insideCallListing)
  {
        if (insideCallListing)
        {
          var SearchBtn2 = new YAHOO.widget.Button("SearchBtn2");
          SearchBtn2.on('click',SearchSubmit);
          var ResetSearchBtn = new YAHOO.widget.Button("ResetSearchBtn");
          ResetSearchBtn.on("click",resetSearch);

          if (showcols['local2']==false && showcols['remote2']==false)
          {
            Dom.addClass(Dom.get('ip_search_row'),'invis');
          }
          if (showcols['direction']==false)
          {
            Dom.addClass(Dom.get('direction_search_row'),'invis');
          }
        }
				if (insideCallListing && showcols['category']==false)
				{
					Dom.addClass(Dom.get('cat_search_row'),'invis');
				} else
				{
					var catNiceMenu = [];
					catNiceMenu.push( { text:'&nbsp;',id:'catsearch-1',onclick:{fn:CatSearchClick} } );
					for (ix in categoryList)
					{
						var cat = categoryList[ix];
						var lbl = categoryList[ix].label;
						if (lbl=='') lbl = '&nbsp;';
						var extrat = '';
						if (cat.value!=0)
						{
							extrat = '<span class="catbox cat'+cat.value+'"></span> ';
						}
						catNiceMenu.push( { text:extrat+lbl,id:'catsearch'+cat.value,onclick:{fn:CatSearchClick} } );
					}
					CatNiceBtn = new YAHOO.widget.Button("CatNice",{type:'menu',menu:catNiceMenu,lazyloadmenu:false});
          
          CatNiceBtn.getMenu().zIndex = 20;
				}				
        
        if (insideCallListing && recorders.length>1 && showcols['recorder']==true)
        {
          var elem = Dom.get('rec');
          for (ix in recorders)
          {
            var rec = recorders[ix];
            var opt = document.createElement('option');
            opt.innerHTML = HtmlQuote( rec.name );
            opt.value = rec.id;
            elem.appendChild(opt);
          }
        } else
        {
          Dom.addClass( Dom.get('id_recorder_row') , 'invis' );
        }
				
				var plus_blks_map =
				{	'enm' : 'nm-plus'
				, 'dnm' : 'nm-plus'
				, 'eid' : 'id-plus'
				, 'did' : 'id-plus'
				, 'eip' : 'ip-plus'
				, 'dip' : 'ip-plus'
        , 'ents': 'nts-plus'
				};
				var plus_blks_vis = {};
				for (ix in plus_blks_map)
				{
					plus_blks_vis[ plus_blks_map[ix] ] = false;
				}
        var searching = false;
        if (!insideCallListing) searching = true;
        for (ix in searchobj)
        {
          if (insideCallListing)
          {
            if (ix=='own')
            {
              if (showownswitch && searchobj[ix]==1)
              {
                UserOrAllBtnGroup.check(0);
              }
              continue;
            }
          }
          searching = true;

          var value = searchobj[ix];

					var plus_ix = ix;

          var fDone = false;
          for (i in search_ids)
          {
            var prop = search_ids[i];
            if (prop.length<4) continue;
            for (j=1;j<=3;j++)
            {
              if (prop[j]==ix)
              {
                Dom.get(prop[0]).value = value;
                // Only local or only remote
                Dom.get('d'+prop[0]).selectedIndex = j;
								plus_ix = 'd'+prop[0];
                fDone = true;
                break;
              }
            }
          }
					if (typeof(plus_blks_map[plus_ix])!='undefined')
					{
						plus_blks_vis[ plus_blks_map[plus_ix] ] = true;
					}
          if (fDone)
          {
            continue;
          }

          var searchid = ix;
          var dateformat = false;
          if (searchid=='fd') {searchid = 'FdInp';dateformat=true;}
          if (searchid=='ld') {searchid = 'LdInp';dateformat=true;}
          if (searchid=='ft') {searchid = 'FtInp';}
          if (searchid=='lt') {searchid = 'LtInp';}
          if (searchid=='fdur') {searchid = 'DurFrom';}
          if (searchid=='ldur') {searchid = 'DurTo';}
          if (dateformat){
            var dt = new Date();
            dt.setTime(value*1000);
            value = formatDate(dt,datef);
          }
          if (searchid=='dir')
          {
            Dom.get('dir').selectedIndex = parseInt(value,10)+1;
            continue;
          }
          if (searchid=='cat')
          {
						var val = parseInt(value,10);
						SetSearchCategory(val);
            continue;
          }
          if (!Dom.get(searchid)) continue;
          if (Dom.get(searchid).type=='checkbox')
          {
            if (value=='1')
            {
              Dom.get(searchid).checked = true;
            }
          } else {
            Dom.get(searchid).value = value;
          }
        }
        if (searching)
        {
          Dom.get('search').style.display = '';
        }
        
				for (ix in plus_blks_vis)
				{
					if (plus_blks_vis[ix]==false)
					{
						search_hideClass( ix );
					} else
          {
            search_showClass( ix );
          }
				}

				for (i=2;i<=5;i++)
        {
          if (showcols['notes'+i]==false)
          {
            Dom.addClass(Dom.get('notes'+i+'_search_row'),'invis');
          } else
          {
            if (NotesLabels[i]!='')
            {
              Dom.get('notes'+i+'_title').innerHTML = HtmlQuote(NotesLabels[i]) + ":";
            }
          }
        }
				
				for(i=1;i<=data_fields_count;i++)
				{
					if(showcols['data'+i] == false)
					{
						Dom.addClass(Dom.get('data'+i+'_search_row'),'invis');
					}
					else if(DataLabels[i]!='')
					{
						Dom.get('data'+i+'_title').innerHTML = HtmlQuote(DataLabels[i]) + ":";
					}
				}
				
        if (insideCallListing)
        {
          if (showcols['linenr']==false)
          {
            Dom.addClass(Dom.get('linenr_search_row'),'invis');
          }
          if (typeof(showcols['username'])=='undefined' || showcols['username']==false)
          {
            Dom.addClass(Dom.get('usrnm_search_row'),'invis');
          }
          if (typeof(showcols['tenant'])=='undefined' || showcols['tenant']==false)
          {
            Dom.addClass(Dom.get('tenant_search_row'),'invis');
          }
					if (showcols['agent']==false)
					{
						Dom.addClass(Dom.get('agent_search_row'),'invis');
					}
          if (!anypm_tra)
          {
            Dom.addClass(Dom.get('transcript_row'),'invis');
          }
          if (typeof(showcols['rem'])=='undefined' || showcols['rem']==false)
          {
            Dom.addClass(Dom.get('id_search_row'),'invis');
          }
        }

  }
  
	function SearchOnReady()
	{
        InitSearchDisplay(true);
        
	}	
	
	function SearchSecondaryInit()
	{
				// this could wait until Search part is opened.
        dateQuickMenu =
				[
					[
						{ text: "<%~DateTime.Day0%>" , onclick:{fn:QuickDateClick}, id:'d0' }
					,	{ text: "<%~DateTime.Day1%>" , onclick:{fn:QuickDateClick}, id:'d1' }
					,	{ text: "<%~DateTime.Day2%>" , onclick:{fn:QuickDateClick}, id:'d2' }
					]
					,[
						{ text: "<%~DateTime.Week0%>" , onclick:{fn:QuickDateClick}, id:'w0' }
					,	{ text: "<%~DateTime.Week1%>" , onclick:{fn:QuickDateClick}, id:'w1' }
					,	{ text: "<%~DateTime.Week2%>" , onclick:{fn:QuickDateClick}, id:'w2' }
					]
					,[
						{ text: "<%~DateTime.Month0%>" , onclick:{fn:QuickDateClick}, id:'m0' }
					,	{ text: "<%~DateTime.Month1%>" , onclick:{fn:QuickDateClick}, id:'m1' }
					,	{ text: "<%~DateTime.Month2%>" , onclick:{fn:QuickDateClick}, id:'m2' }
					]
					,[
						{ text: "<%~DateTime.Year0%>" , onclick:{fn:QuickDateClick}, id:'y0' }
					,	{ text: "<%~DateTime.Year1%>" , onclick:{fn:QuickDateClick}, id:'y1' }
					,	{ text: "<%~DateTime.Year2%>" , onclick:{fn:QuickDateClick}, id:'y2' }
					]
				]
        var DateQuickBtn = new YAHOO.widget.Button("DateQuick",{type:'menu',menu:dateQuickMenu});
    		var oFdCalBtn = new YAHOO.widget.Button({
												type: "push",
												id: "FdCalBtn",
												container: "TdFd" });
    		var oLdCalBtn = new YAHOO.widget.Button({
												type: "push",
												id: "LdCalBtn",
												container: "TdLd" });
        Event.on('FdCalBtn','click',OnCalBtnClick,["FdCalBtn",oFdCalBtn,dialogfd,calfd,"FdInp","<%~Web.DateFromColon%>"]);
        Event.on('LdCalBtn','click',OnCalBtnClick,["LdCalBtn",oLdCalBtn,dialogld,calld,"LdInp","<%~Web.ToColon%>"]);
	}

	function savedQueryClick(param1,param2,targetobj)
	{
		var dbid = parseInt(targetobj.id.substr(5),10);
		addData('savq',dbid);
		NoActionSubmit();
	}

	function saveQueryClick()
	{
		qname = prompt("<%~Web.QueryName%>",'');
		if (qname=='' || qname==null) return;
    SearchPrepareGeneral();
		addData('act','addquery');
		addData('queryname',qname);
		ActionSubmit();
	}

	function searchKeyUp(a,obj,c)
	{
		if (obj[0].keyCode==46)
		{
			var dbid = parseInt(obj[1].id.substr(5),10);
			if (confirm("<%~Web.ConfirmQueryDelete%>"))
			{
				addData('queryid',dbid);
				addData('act','delquery');
				ActionSubmit();
			}
		}
  }