<?php

require_once('general.php');

HandlePage($dbintf);

function HandlePage($dbintf)
{
  global $rpl,$configs,$msg,$lng,$rooturl;
	
	$haveAccess = ($dbintf->actuinfo['permissions']&PM_CONFIG)
  || ($dbintf->actuinfo["permissions"]&PM_TENANT_ADMIN_AUDIT)
  ;
  
  $isFullAdmin = ($dbintf->actuinfo['permissions']&PM_CONFIG) != 0;

  if (!$haveAccess)
  {
    echo 'Permission denied';
    exit;
  }

  $data = '';
  $MultiTenancy = ($dbintf->GetConfigValue('MultiTenancy')!=0);
  
  LogAction( "View audit trail in database" , array('level'=>'view') );

	// ready with database
  $dbintf->close();

  $data .= GeneralJSData();
  
  $data .= 'var MultiTenancy = ' . ($MultiTenancy?1:0) . ";\n";

  $template_content = file_get_contents('../apresa/templ/auditdb.htm');

  // template replacements:
  $rpl['msg'] = message($msg);
  $rpl['nav'] = '';
  $rpl['MAINFORM'] = '<form id="mainform" method="POST"></form>';
  $rpl['FOOTER'] = '';
  $rpl['data'] = $data;
  $rpl['JSGEN'] = file_get_contents('../apresa/templ/general.js');
  $rpl['header'] = GetHeader();
  $template_content = do_replace_tags($template_content);
  echo $template_content;
}



?>
