<?php

require_once('general.php');
require_once('cedb.php');
require_once 'listinggen.php';
require_once 'ceshared.php';
HandlePage($dbintf);

function epochToString($epoch){
	if($epoch){
		return date("l d-F-Y", $epoch);	
	}else{
		return "";
	}
}

function determineNextDate($scheduleType)
{
      $nextDate=0;
      switch ($scheduleType) {
        case 0:
          $curDay = date( "j");
          $curMonth = date( "n");
          $curYear = date( "Y");
          $nextDate = strtotime($curYear."/".$curMonth."/".$curDay. " 00:01 +1 days");
          
          break;
        case 1:
          $curWeekday = (int) date( "w", time());
          $wantedWeekday = (int) $_POST['day'];
          
          $diff = $wantedWeekday-$curWeekday;
          
          $curDay = date( "j");
          $curMonth = date( "n");
          $curYear = date( "Y");
          
          if($diff>0){						
            $nextDate = strtotime($curYear."/".$curMonth."/".$curDay. " 00:01 +".$diff." days");
          }else{
            $nextDate = strtotime($curYear."/".$curMonth."/".$curDay. " 00:01 +".$diff." days, +1 weeks");
          }					
          
          break;
        case 2:
          //$curDay = date( "j");
          $curMonth = date( "n");
          $curYear = date( "Y");
          $nextDate = strtotime($curYear."/".$curMonth."/1 ". " 00:01 +1 months");
          
          break;
      }
      return $nextDate;
}  

function HandlePage($dbintf)
{
  global $rpl,$configs,$msg,$rooturl,$configs_s, $lng;
  $actuinfo = $dbintf->GetActiveUserInfo();
  $handler = new ListingHandler();
  $handler->filterData = false;
  $handler->search_accepted[] = 'usrnm';
  $handler->ParseSearch();
  
	if (int_ensure_defined($configs_s['calleval'])==0)
	{
    echo 'Feature is not enabled';
    exit;
	}

  if (CheckCePm(PM_CE_SCHEDULING)==false)
  {
    echo 'Permission denied';
    exit;
	}

  $cedb = new CEDB($dbintf);
  
  
  //triggerSchedules($actuinfo['accid'],$cedb);
  
  $act = $_POST['act'];
  if ($act!='')
  {
    $search_accepted = array
    ( 'r1', 'l1', 'c1', 'r2', 'l2' , 'rn' , 'ln' , 'cn'
    , 'nts', 'ents', 'nts2', 'nts3', 'nts4', 'nts5', 'ann', 'tra'
	, 'dts1', 'dts2', 'dts3', 'dts4', 'dts5'
    , 'fd' , 'ld' , 'id' , 'ip' , 'nm'
    , 'eid' , 'eip' , 'enm' , 'dir', 'ft', 'lt'/*, 'own' */
    , 'fdur', 'ldur', 'lnr', 'cat', 'rem'/*, 'rb' */
    , 'usrnm'
    );
  	if ($act=='editSchedule')
  	{
			LogAction('Edit AgEv schedule',array('name'=>$_POST['filtername']) );
      $qspec = array();
      foreach ($search_accepted as $searchix){
        if (str_ensure_defined($_POST[$searchix])!=''){
          $qspec[$searchix] = $_POST[$searchix];
        }
      }

      $scheduleType = $_POST['type'];
      $nextDate = determineNextDate($scheduleType);
      
      $qspec = ArrayToString($qspec);
						
			if(CheckCePm(PM_CE_MANAGE)==true){
				if($_POST['supervisor']!=''){
					$dbid = $cedb->EditSchedule($_POST['projectid'],$_POST['filtername'],$scheduleType,$_POST['day'],$_POST['moving'],$nextDate,NULL,$_POST['callcnt'],$_POST['add_per_id'],$_POST["supervisor"],$_POST['filterproject'],$qspec);
				}
			}else if(CheckCePm(PM_CE_SUPERVISOR)==true){
				$dbid = $cedb->EditSchedule($_POST['projectid'],$_POST['filtername'],$scheduleType,$_POST['day'],$_POST['moving'],$nextDate,NULL,$_POST['callcnt'],$_POST['add_per_id'],$actuinfo["accid"],$_POST['filterproject'],$qspec);
			}
      
      //$redirect_url_ref = substr($_SERVER['PHP_SELF'],1).'?savq=' . $dbid;
		}
    if ($act=='runSchedule')
    {
      //echo $_POST['scheduleid']; exit;
      // perform the schedule, regardless of trigger date
      // first find its data
			if(CheckCePm(PM_CE_MANAGE)==true){
				$schedules = $cedb->GetSchedules($_POST['supervisorid']);
			}else if(CheckCePm(PM_CE_SUPERVISOR)==true){
				$schedules = $cedb->GetSchedules($actuinfo['accid']);
			}
      foreach($schedules as $schedule)
      {
        if ($schedule['id']==(int)$_POST['scheduleid'])
        {
          LogAction('Run AgEv schedule',array('name'=>$schedule['name']) );
          // perform now
          addNewCallsToProject($schedule , $cedb);
        }
      }
    }
  	if ($act=='delSchedule')
  	{
			$scheduleid = (int) $_POST['scheduleid'];
      $schedules = $cedb->GetSchedules($actuinfo["accid"]);
      foreach($schedules as $schedule)
      {
        if ($schedule['id']==(int)$_POST['scheduleid'])
        {
          LogAction('Delete AgEv schedule',array('name'=>$schedule['name']) );
          $ret = $cedb->DelSchedule($scheduleid);
          if ($ret==1)
          {
            $msg[] = new Msg(MSG_ERR,'Cannot delete this project. It contains calls.');
          }
        }
      }
		}
    if ($act=='addSchedule')
    {
			LogAction('Add AgEv schedule',array('name'=>$_POST['filtername']) );
			$qspec = array();
			foreach ($search_accepted as $searchix){
				if (str_ensure_defined($_POST[$searchix])!=''){
				    $qspec[$searchix] = $_POST[$searchix];
				}
			}
			
			$qspec = ArrayToString($qspec);
			$scheduleType = $_POST['type'];
      $nextDate = determineNextDate($scheduleType);

			if(CheckCePm(PM_CE_MANAGE)==true){
				if($_POST['supervisor']!=''){
					$dbid = $cedb->AddSchedule($_POST['filtername'],$scheduleType,$_POST['day'],$_POST['moving'],$nextDate,$_POST['callcnt'],$_POST['add_per_id'],$_POST['supervisor'],$_POST['filterproject'],$qspec);
				}
			}else if(CheckCePm(PM_CE_SUPERVISOR)==true){				
				$dbid = $cedb->AddSchedule($_POST['filtername'],$scheduleType,$_POST['day'],$_POST['moving'],$nextDate,$_POST['callcnt'],$_POST['add_per_id'],$actuinfo["accid"],$_POST['filterproject'],$qspec);					
			}
			
	        //$redirect_url_ref = substr($_SERVER['PHP_SELF'],1).'?savq=' . $dbid;
    }

    // redirect
    $_SESSION['msg'] = $msg;
    header('Location: '.$rooturl.'ceschedule.php');
		exit;
  }	
	
	$mygroups=$cedb->getMyGroups($actuinfo["accid"]);		
	$subgroups=array();
	$subgroups=array_merge($subgroups, $mygroups);
	foreach($mygroups as $group){
		$subgroups=array_merge($subgroups, $cedb->getSubGroups($group));
	}
	
	$users=array();
	if(CheckCePm(PM_CE_MANAGE)){
		$users=$cedb->getAllUsers();
	}else if(CheckCePm(PM_CE_SUPERVISOR)){
		$users=$cedb->getUsersFromGroups($subgroups);
	}
	
	$supervisors=array();
	foreach($users as $user){
		$db2 = new DBInterface('');
		$db2->cloneInit( $dbintf );
		$db2->SetCurrentUserId( $cedb->getUserID($user));
		if(($db2->actuinfo['permissions']&PM_CE_SUPERVISOR)!=0){
			array_push($supervisors,$user);
		}			
	}
	
	$supervisoroptions="";
	foreach($supervisors as $user)
	{
		$supervisoroptions.="<option value=".$user.">".HtmlQuote($cedb->getUsername($user))."</option>";
	}	

	$projectoptions="";
	$projects = $cedb->GetProjects();
	$first = true;
	foreach($projects as $project)
	{
		$projectoptions.="<option value=".$project["id"].">".HtmlQuote($project["name"])."</option>";
	}

  
	$forms = $cedb->GetForms();
	$data = 'var evalforms = [';
	$first = true;
	foreach($forms as $form)
	{
		if ($first) $first = false;
		else $data .= ',';
		$data .= '{ name: "' . JSQuote($form['name']) . '"';
		$data .= ' , id: ' . $form['id'];
		$data .= ' , questions: ' . $form['qcnt'];
		$data .= '}' . "\r\n";
	}
	$data .= '];' . "\r\n";
	
	$schedules = $cedb->GetSchedules($actuinfo["accid"]);
	$data .= 'var schedules = [';
	$first = true;
	
	foreach($schedules as $schedule){
		if ($first) $first = false;
		else $data .= ',';
		$data .= '{ id: "' . JSQuote($schedule['id']) . '"';
		$data .= ' , name: "' . JSQuote($schedule['name']) . '"';
		$data .= ' , supervisorid: "' . JSQuote($schedule['supervisor']) . '"';
		$data .= ' , supervisor: "' . JSQuote($cedb->GetUserName($schedule['supervisor'])) . '"';
		$data .= ' , projectid: "' . JSQuote($schedule['project']) . '"';
		$data .= ' , project: "' . JSQuote($cedb->GetProjectName($schedule['project'])) . '"';
		$data .= ' , callcnt: "' . JSQuote($schedule['callcnt']) . '"';
		$data .= ' , add_per_id: "' . JSQuote($schedule['add_per_id']) . '"';
		$data .= ' , typeid: "' . JSQuote($schedule['type']) . '"';
		$data .= ' , day: "' . JSQuote($schedule['day']) . '"';
		$data .= ' , moving: "' . JSQuote($schedule['moving']) . '"';
		$data .= ' , nxtdate: "' . JSQuote(defFormatDateNnDow($schedule['nexttrigger'])) . '"';
		$data .= ' , lstdate: "' . JSQuote(defFormatDateNnDow($schedule['lasttrigger'])) . '"';
		$data .= ' , filter: "' . JSQuote($schedule['qspec']) . '"';
		$data .= '}' . "\r\n";
	}
	
	$data .= '];' . "\r\n";
	//var call_list = $dbintf->GetCallList($this->sk,$this->sd,$this->search_use,$this->listconfig);

  $defcolors = GetDefaultCategoryColors();
  $catColors = array();
  for ($i=1;$i<=10;$i++)
  {
    if (!isset($configs['CatColor'.$i]))
    {
      $configs['CatColor' . $i] = $defcolors[$i-1];
    }
    $catColors[] = $configs['CatColor' . $i];
  }
  $data .= 'var catColors = ' . json_encode($catColors) . ";\r\n";
	
	$options = array();
	$options['callback'] = 'CeAddExtraJsCols';
	
	$calldata = '';
	$calldata .= 'var categoryList =' . "\r\n";
	  $calldata .= '[	{label:"'.JSQuote($lng->Get('Main.None')).'",value:"0"}' . "\r\n";
	  for ($i=1;$i<=10;$i++)
	  {
			// JSQuote($lng->Get('Cols.category')).' '.($i+1)
			$lbl = str_ensure_defined($configs['CatLabel'.$i]);
			//if ($lbl=='') $lbl = $lng->Get('Cols.category') . ' ' . $i;
			$calldata .= ', {label: "'.JSQuote($lbl).'",value:'.$i.'}';
		}

	  $calldata .= '];' . "\r\n";
	//$calldata .= $handler->GetBasicJsData($options);

// copied from listinggen.php	
		$colkeys = array("playlink","flags","startdate","length","waittime","direction"
		, "category","notes","notes2","notes3","notes4","notes5"
		, "data1", "data2", "data3", "data4", "data5"
		, "rname", "remote", "remote2", "cname", "connected"
		, "direction2"
		, "lname", "local", "local2","linenr"
		,"checksum","rem");
	  
    $calldata .= 'var showcols = {';
	  foreach ($colkeys as $colkey)
	  {
	    $calldata .= $colkey.': ' . ToInt($configs['col_'.$colkey]).',';
	    //$data .= "]";
	  }
	  $calldata .= 'xyend:0};' . "\r\n";
    
    $calldata .= "var NotesLabels = [];\n";
    for ($i=2;$i<=5;$i++)
    {
      $key = 'NotesLabel' . $i;
      $calldata .= "NotesLabels[$i] = \"" . JSQuote( $configs[$key] ) . "\";\n";
    }
	
	$calldata .= "var DataLabels = [];\n";
	for ($i=1;$i<=5;$i++)
    {
      $key = 'DataLabel' . $i;
      $calldata .= "DataLabels[$i] = \"" . JSQuote( $configs[$key] ) . "\";\n";
    }
	
  
	$calldata .= $data;
	$calldata .= GeneralJSData();
	
	if(CheckCePm(PM_CE_MANAGE)==true){
		$calldata .= "var manager=1";
	}else{
		$calldata .= "var manager=0";
	}

	LogAction('View AgEv schedules',array('level'=>'view'));

  // ready with database
  $dbintf->close();

  $template_content = file_get_contents('../apresa/templ/ceschedule.htm');
  $handler->SetDefReplacements();
  // template replacements:
  $rpl['msg'] = message($msg);
  $rpl['nav'] = '';
  $rpl['MAINFORM'] = '<form id="mainform" method="POST"></form>';
  $rpl['FOOTER'] = '';
  $rpl['projects_lst'] = $projectoptions;
	$rpl['supervisor_lst'] = $supervisoroptions;
  $rpl['data'] = $calldata;
  $rpl['JSGEN'] = file_get_contents('../apresa/templ/general.js');
  $rpl['filterblk'] = file_get_contents('../apresa/templ/list_searchblk.htm');
  $rpl['cejsgen'] = file_get_contents('../apresa/templ/cejsgen.js');
  $rpl['ceblock'] = file_get_contents('../apresa/templ/ceblock.htm');
  $rpl['header'] = GetHeader();
  $template_content = do_replace_tags($template_content);
  echo $template_content;
}



?>
