<?php

require_once('general.php');

HandlePage($dbintf);

function HandlePage($dbintf)
{
  global $rpl,$configs,$msg,$lng,$rooturl;

  if (($dbintf->actuinfo['permissions']&PM_CONFIG)==0)
  {
    echo 'Permission denied';
    exit;
  }

  $act = $_POST['act'];
  if ($act!='')
  {
    if ($act=='XXXXXX')
    {
		}
    // redirect
    $_SESSION['msg'] = $msg;
    header('Location: '.$rooturl.'cluster.php');
    exit;
  }

  $configs = $dbintf->LoadConfigs();
  
  LogAction("View H.A. cluster status",array('level'=>'view'));
  
  // ready with database
  $dbintf->close();

	// get cluster status
	msg_signal_service($msg,'cluster info');
	
	$cluster_crm = file_get_contents(DATA_PATH . '/cluster_crm.dat');
	$cluster_drbd = file_get_contents(DATA_PATH . '/cluster_drbd.dat');
	
	$data = '';
	$data .= 'cluster_crm = "' . JsQuote($cluster_crm) . '"' . ";\r\n";
	$data .= 'cluster_drbd = "' . JsQuote($cluster_drbd) . '"' . ";\r\n";
  $data .= GeneralJSData();

  $template_content = file_get_contents('../apresa/templ/cluster.htm');

  // template replacements:
  $rpl['msg'] = message($msg);
  $rpl['nav'] = '';
  $rpl['MAINFORM'] = '<form id="mainform" method="POST"></form>';
  $rpl['FOOTER'] = '';
  $rpl['data'] = $data;
  $rpl['JSGEN'] = file_get_contents('../apresa/templ/general.js');
  $rpl['header'] = GetHeader();
  $template_content = do_replace_tags($template_content);
  echo $template_content;
}



?>


