<?php
include 'utility.php';

if (isset($_GET['f'])==false)
{
	exit;
}
$fn = $_GET['f'];
if ($fn=='manual' || $fn=='manual/')
{
	$fn = 'manual/index.html';
}
$basedir = dirname(__FILE__);
$fullfn = realpath( $basedir . '/' . $fn );
// serve the manual
if (strpos($fullfn,realpath($basedir.'/manual'))===0)
{
	if (file_exists('../apresa/conf/opt_ManualAccess_admins'))
	{
		$NO_LOGIN_PAGE = true;
		include('general.php');
		if (($dbintf->actuinfo['permissions']&PM_CONFIG)==0)
		{
			echo 'Permission denied';
			exit;
		}
	} else if (file_exists('../apresa/conf/opt_ManualAccess_users'))
	{
		$NO_LOGIN_PAGE = true;
		include('general.php');
		if (!isset($_SESSION['uid']))
		{
			// not logged in
			echo 'Permission denied';
			exit;
		}
	}
	if (file_exists($fullfn)==false)
	{
		echo "ERROR. File not found: " . HtmlQuote($fn);
		exit;
	}
	if (is_file($fullfn)==false)
	{
		echo "ERROR. Not a file: " . HtmlQuote($fn);
		exit;
	}
	$pi = pathinfo($fullfn);
	$mime = '';
	$ext = '';
	if (isset($pi['extension']))
	{
		$ext = $pi['extension'];
	}
	if ($ext == 'css') $mime = 'text/css';
	if ($ext == 'js') $mime = 'text/javascript';
	if ($mime!='')
	{
		header('Content-Type: ' . $mime);
	}
	readfile($fullfn);
} else
{
	echo "Unavailable: " . HtmlQuote($fn);
}

?>