<?php

function parse_ini($fn)
{
  $lines = file($fn);
  // error reading file
  if ($lines===FALSE)
  {
    return FALSE;
  }
  return parse_ini_data($lines);
}

function parse_ini_data($lines)
{
  foreach ($lines as $line)
  {
    $line = trim($line);
    $linelen = strlen($line);
    if ($linelen==0 || isset($line[0])==false)
    {
      continue;
    }
    if ($line[0]=='[')
    {
      $heading = substr($line,1,-1);
    } else {
      $eqpos = strpos($line,'=');
      if ($eqpos===false)
      {
        continue;
      } else {
        $param = substr($line,0,$eqpos);
        $value = substr($line,$eqpos+1);
        $result[$heading][$param] = $value;
      }
    }

  }
  return $result;
}
?>