<?php

require_once 'general.php';
require_once 'utility.php';

HandlePage($dbintf);

function ParseDateTime($dt)
{
  return strtotime($dt);
}

function HandlePage($dbintf)
{
  global $rpl,$configs,$actuinfo,$msg;
	
	if ( ($dbintf->actuinfo['permissions']&(PM_CONFIG) )==0 )
  {
		echo 'Permission denied';
		exit;
	}

  $act = $_POST['act'];
  if ($act!='')
  {
    // nothing so far
  }

  // Call listing will be retrieved asynchroneously
  LogAction('View live calls',array('level'=>'view'));

  $dbintf->close();

  $template_content = file_get_contents('../apresa/templ/live.htm');

  $webdata = '';
  $webdata .= GeneralJSData();


  // template replacements:
  $rpl['msg'] = message($msg);
  $rpl['search'] = '';
  $rpl['MAINFORM'] = '<form id="mainform" method="POST"></form>';
  $rpl['FOOTER'] = '';
  $custom_list_css = '../apresa/templ/custom/list_custom.css';
  $list_css = file_get_contents('../apresa/templ/genlist.css');
  if ( file_exists($custom_list_css) )
  {
    $list_css .= file_get_contents($custom_list_css);
  }
  $rpl['genlist_css'] = $list_css;
  $rpl['data'] = $webdata;
  $rpl['JSGEN'] = file_get_contents('../apresa/templ/general.js');
  $rpl['header'] = GetHeader();
  $template_content = do_replace_tags($template_content);
  echo $template_content;
}



?>

