<?php

require_once('general.php');

HandlePage();


function HandlePage()
{
  global $rpl,$configs,$msg,$lng,$rooturl,$dbintf,$result,$ntpd,$timesyncd;
	
  if (($dbintf->actuinfo['permissions']&PM_CONFIG)==0)
  {
    echo 'Permission denied';
    exit;
  }
	
	$result = array();
	exec('ntpq -p',$result, $ntpd);
  if($ntpd !== 0)
  {
    exec('timedatectl timesync-status', $result, $timesyncd);
  }
	
	
	
}
LogAction("View NTP diagnostic report.",array('level'=>'view'));
?>

<h1>NTP diagnostic report</h1>

<textarea cols="83" rows="10">
<?php 
foreach ($result as $line)
{
	echo $line . "\n";
}
?>
</textarea>

<h3>Explanation</h3>

<?php

echo "NTP process: " . ($ntpd === 0 ? "ntpd" : "systemd-timesyncd") . "</br></br>";

if($ntpd === 0)
{
  echo "<table border='1'>";
  echo "<tr><td>remote<td>The remote IP address or IP name of the NTP server.";
  echo "<tr><td>reach<td>If it is 0, it cannot reach it.";
  echo "If the NTP server is remote, check if the gateway IP address is correct.";
  echo "If so, also check your firewall / router settings.";
  echo "NTP uses UDP port number 123.";
  echo "<tr><td>delay<td>Communication delay between this host and the NTP server.";
  echo "<tr><td>offset<td>Difference in milliseconds [ms], between local and NTP time.";
  echo "This should be less than 100 ms.";
  echo "It can take minutes to synchronize,";
  echo "especially if the offset is large.";
  echo "</table>";
}
?>

