<?php

require_once('general.php');
require_once('smbgen.php');

HandlePage($dbintf);

function HandlePage($dbintf)
{
  global $rpl,$configs,$msg,$lng,$rooturl;

  if (($dbintf->actuinfo['permissions']&PM_CONFIG)==0)
  {
    echo 'Permission denied';
    exit;
  }



  $act = $_POST['act'];
  if ($act!='')
  {
    if ($act=='start')
    {
			$cfgkeys = array('RBckSrcType','RWinDomain','RWinUsr','RWinPwd','RBckServer','RBckShare'
					,'RBckSubdir','RBckFile','RBckPath','RBckDisk','RBckRestoreMethod','RBckFrom','RBckTo');
      $configs_rb = array();
      foreach ($cfgkeys as $cfgkey)
      {
        if (isset($_POST[$cfgkey]))
        {
          $configs_rb[$cfgkey] = $_POST[$cfgkey];
          if ($cfgkey=='RWinPwd')
          {
            $configs_rb[$cfgkey] = encrypt($configs_rb[$cfgkey]);
          }
        }
      }
      if ($configs_rb['RBckRestoreMethod']==0)
      {
        LogAction('Restore calls from backup');
      } else
      {
        LogAction('Full system restore from backup');
      }
      if ($configs_rb['RBckServer'])
      {
          $ret_lookup = NmbLookupIPAddr($configs_rb['RBckServer'],null);
          if ($ret_lookup===false)
          {
            $configs_rb['RBckServerIP'] = $configs_rb['RBckServer'];
          } else
          {
            $configs_rb['RBckServerIP'] = $ret_lookup;
          }
      }
      // check disk
      if (isset($configs_rb['RBckDisk']))
      {
        // check if in array
        $found = false;
        $disks = FindDisks();
        foreach ($disks as $disk)
        {
          if ($disk == $configs_rb['RBckDisk'])
          {
            $found = true;
          }
        }
        if ($found==false)
        {
          $msg[] = new Msg(MSG_ERR,'Invalid backup disk');
          $_SESSION['msg'] = $msg;
          header('Location: '.$rooturl.'restore.php');
          exit;
        }
      }
      $configs_rb['RBckAct'] = 2;
      $dbintf->SetConfigsPart($configs_rb,'rb');

      if (msg_signal_service($msg,'restore start'))
      {
	      // log out
 				end_of_session();
				// sleep some time, so that backup restore has started
				sleep(3); // in seconds
    		header('Location: '.$rooturl);
	      exit;
	    }
    }

    // redirect
    $_SESSION['msg'] = $msg;
    header('Location: '.$rooturl.'systools.php');
    exit;
  }
	
	LogAction("Viewed backup restore page.",array('level'=>'view'));

  // ready with database
  $dbintf->close();

  // find local disks
  $disks = FindDisks();
    
  $data = GeneralJSData();
  
  $data .= 'var Disks = ' . json_encode($disks) . ";\r\n";
  
  $template_content = file_get_contents('../apresa/templ/restore.htm');

  // template replacements:
  $rpl['msg'] = message($msg);
  $rpl['nav'] = '';
  $rpl['MAINFORM'] = '<form id="mainform" method="POST"></form>';
  $rpl['FOOTER'] = '';
  $rpl['data'] = $data;
  $rpl['JSGEN'] = file_get_contents('../apresa/templ/general.js');
  $rpl['header'] = GetHeader();
  $template_content = do_replace_tags($template_content);
  echo $template_content;
}



?>
