<?php

require_once('general.php');

HandlePage($dbintf);

function HandlePage($dbintf)
{
  global $rpl,$configs,$msg,$lng,$rooturl;
	
	if ( ($dbintf->actuinfo['permissions']&PM_CONFIG)==0 )
  {
    echo 'Permission denied';
    exit;
  }

  if ($_POST['act']!='')
  {
    //var_dump($_POST);
    if ($_POST['act']=='add'
     || $_POST['act']=='edit')
    {
      $data = array();
      $data['name'   ] = $_POST['name'];
      $data['enabled'] = (int) $_POST['enabled'];
      $data['maxdur' ] = (int) $_POST['maxdur'];

      $search_accepted = array
      ( 'fd' , 'ld' , 'id'
      , 'fdur', 'ldur'
      );
      $qspec = array();
      foreach ($search_accepted as $searchix){
        if (str_ensure_defined($_POST[$searchix])!=''){
          $qspec[$searchix] = $_POST[$searchix];
        }
      }
      $data['filter'] = ArrayToString($qspec);      
    }
    
    if ($_POST['act']=='add')
    {
      $dbintf->AddTScriptPlan($data);
    }
      
    if ($_POST['act']=='edit')
    {
      $id = (int) $_POST['dbid'];
      $dbintf->EditTScriptPlan($id,$data);
    }
    
    if ($_POST['act']=='del')
    {
      $id = (int) $_POST['dbid'];
      $dbintf->DeleteTScriptPlan($id);
    }
    
    // redirect
    $_SESSION['msg'] = $msg;
    header('Location: '.$rooturl.'tscriptplans.php');
		exit;
  }
  
  
  $data = '';
  $plans = $dbintf->GetTScriptPlans();
  $data .= "var plans = " . json_encode($plans) . ";\n";
  
  $data .= "var ts_today = " . mktime(0,0,0) . ";\n";

  LogAction( "View transcription plans" , array('level'=>'view') );

	// ready with database
  $dbintf->close();

  $data .= GeneralJSData();

  $template_content = file_get_contents('../apresa/templ/tscriptplans.htm');

  // template replacements:
  $rpl['search_outside_js'] = file_get_contents('../apresa/templ/search_outside.js');
  $rpl['msg'] = message($msg);
  $rpl['nav'] = '';
  $rpl['MAINFORM'] = '<form id="mainform" method="POST"></form>';
  $rpl['FOOTER'] = '';
  $rpl['data'] = $data;
  $rpl['JSGEN'] = file_get_contents('../apresa/templ/general.js');
  $rpl['header'] = GetHeader();
  $template_content = do_replace_tags($template_content);
  echo $template_content;
}








